c-----------------------------------------------------------------------
      program calanalysis
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40            Level: 110415          MAIN
c
c
c     Copyright (c) 2006-2011 by Exponent, Inc.         
c
c
c --- PURPOSE: This programs is based on CALPOST. Its purpose is to rank 
c     concentrations (for different averaging times) for all the days 
c     contained in the CALPUFF output *.con files (or flux files) with
c     concentrations above a certain threshold.
c     The ranking key group can be "total" or any individual group. 
c
c
c --- UPDATES:
c --- Version 6.38 level 110301 to 6.39 level 110311
c --- Changes I. Lee, TRC
c          - Fix bug when decrementing by less than 24 hours
c            Modified:  INCR
c
c --- Version 6.37 level 110124 to 6.38 level 110301
c          - Add Dataset v2.2 (use data only if mass units)
c            Modified:  HEAD.ANS
c                       GETHEAD
c
c --- Version 6.36 level 101116 to 6.37 level 110124
c --- Changes F. Robe, TRC
c --- Changes I. Lee, TRC
c          - Increase format of output (FORMAT 1018 & 202)
c
c --- Version 6.35 level 090313 to 6.36 level 101116
c --- Changes F. Robe, TRC
c --- Changes I. Lee, TRC
c          - Address differences in output format when CALANALYSIS is run 
c            on PC vs. linux machine
c
c --- Version 6.34 level 090227 to Version 6.35 level 090313
c --- Changes C. Escoffier-Czaja, TRC
c          - A format issue appeared for the time series output
c            format 212 and 216 have been changed
c --- Version 6.33 level 080502 to Version 6.34 Level 090227
c --- Changes C. Escoffier-Czaja, TRC
c          - Remove warning messages in TESTHEAD when some parameters
c            from the CALPUFF files do not match the parameters of the first
c            file. These parameters may be different and it is still OK.
c	     MODIFIED: TESTHEAD
c          - Add a call to subroutine ALLCAP to make sure the species are
c            in CAPITAL letters
c          - Add a check on the number of files called, to make sure it does
c            not exceed the maximum
c          - Modify the language for accommodating the case when Rank 1 is
c            not a violation.
c          - Find the number of violations when averaging time equal 
c            or larger than half the entire period (nhalf < 2) - was omitted before
c
c --- Version 6.32 Level 080422 to Version 6.33 Level 080502
c --- Changes C. Escoffier-Czaja, TRC
c          - Remove check that generic format has three columns.
c            ONLY two columns are read: X and Y.
c          - Correction of initialization of xmaxval.  Initiate now
c            from 1 to nipt2
c          - Add the statment of the total number of violations and
c            the list of receptors and days with a violation
c --- Version 6.31 Level 080418 to Version 6.32 Level 080422
c --- Changes I. Lee, TRC
c          - Change list file output from 'io1' to 'iolst'
c          - Change screen output from '*,*' to 'iomsg,*'
c          - Add subroutine FIN (add 'qa.ans') - adds run-time to LST file
c          - Add subroutines DATETM,ETIME,YR4C from CALUTILS Version: 2.55 Level: 070327
c          - Add key (search for "KEY_CODE")
c --- Version 6.30, Level 080305 to Version 6.31, level 080418
c --- Changes C. Escoffier-Czaja, TRC
c          - Make sure the generic receptor file has 3 columns
c            Code will stops if not
c          - Add a ifrmt=2, allowing to read the Rank file format
c            as a generic file (skipping the header)
c --- Version 6.29, Level 080111 to Version 6.30, Level 080305
c --- Changes I. Lee, TRC
c          - DLL can not have screen output or stops so replace
c            all instances of "write(*,*)" and "stop" to allow
c            for easy conversion of the Fortran code to DLL format
c --- Changes C. Escoffier-Czaja, TRC
c          - Remove Error message if maxfile is larger than 50
c            All input file open ID number beside CALPUFF input files were 
c            changed to be below 20 - (080131)
c          - Change outputs from end time to starting period
c          - Add a test to check CALPOST Rank file match the concentrations
c            files provided
c          - Make changes so results for receptors listed in generic file 
c            are the same as results for receptors in CALPOST Rank output
c            file -(080305)
c          - Initialize all arrays because when DLL run ARRAY are not 
c            re-initialized
c
c --- Version 6.28, level 071025 to Version 6.29, level 080111
c --- Changes C. Escoffier-Czaja, TRC
c          - Change order of printing out the sources results
c          - Change printing output format in the list file
c          - Compute the remaining concentrations for all sources included in the ALL
c            but not listed in the control input file (new array OTHSRC)
c          - Add a check that Rank file (output of CALPOST) has the same averaging time
c            as the averaging time requested in CALANALYSIS.INP
c          - xmaxval2 initialization corrected from 0 to -99999.  Since in cumulative analysis
c            increment expanding sources are counted as negative, max allconc can actually be negative
c
c --- Version 6.27, Level 071001 to Version 6.28, Level 071025
c --- Changes C. Escoffier-Czaja, TRC
c          - Add possibility to choose to exclude or include Rank 1 in the additional analysis
c          - Remove the cut off at 2232 hours and replace it by nhalf = nper/nhour:
c            Rank 2 does not exist if nhalf < 2. 
c
c --- Changes I. Lee, TRC
c          - Change concentration write format from (1pe11.4) to (f9.3).
c          - Add "receptors.dat" filename to LST file.
c          - Explicitly close control file (in2).
c          - Merge DAT into LST.
c          - Modify LST file.
c
c          - Fix bug where incorrect concentrations were computed and written
c            out when the number of hours being processed was not an exact
c            multiple of the selected averaging period. [Search for "MXPER_FIX"]
c
c          - Fix FORMAT of input READ statements for real numbers from fx.y 
c            where y<>0 to fx.0 because if the number being read in does not
c            contain a decimal point, Fortran will incorrectly assign "y"
c            decimal places to the right of the decimal point as specified in
c            the FORMAT statement. For example, if the format of the READ
c            statement was f8.2 and the number being read in was "52", Fortran
c            would incorrectly interpret "52" as "0.52". This error only occurs
c            on input READ and not on output WRITE.
c
c          - Increase limit on path/filename character string lengths from 70 to
c            132 by replacing COMLINE with the latest version from CALUTILS.FOR 
c            (CALUTILS   Version: 2.55     Level: 070327), modifying FILNAM.ANS,
c            modifying the format of the control file READ statements, and the
c            relevant variable definitions to CHARACTER*132.
c
c --- Version 6.26, Level 070924 to Version 6.27, level 071001
c --- Changes I. Lee, TRC
c          -  Change "CALANLS" to "CALANALYSIS"
c          -  Add standard header to LST file
c ---     DGS
c          -  Restructure how QA problems are communicated to make it
c             easier to port to a DLL for calls from a GUI (stops
c             are moved to main program, controlled by HALT132)
c          -  Remove file unit numbers 5 and 6 (VB GUI conflicts)
c          -  List file is unit iolst, not in3 (iolst was not opened)
c          -  Fix write statement introduced in (070813) that exceeds
c             72 fixed-line limit (allconc)
c          -  Fatal errors were written to the screen but execution
c             continued (main) 
c         Modified: (main), GETHEAD, SKIPREC, GETRCRD, RDCONC,
c                   MLTBOUND, TESTHEAD,
c                   INCR, JULDAY, GRDAY, UNCOMPRS
c
c --- Version 6.25, level 070813 to version 6.26, level 070924
c --- Changes C. Escoffier-Czaja, TRC
c          -  In IMORE option, fix the error that when all receptors
c             are below the thresh_lim, all the files need to be read and store
c             in the scratch file (changes made on 070815).
c          -  Finish to fix it on 070914.
c --- Version 6.24, level 070425 to version 6.25, level 070813
c --- Changes C. Escoffier-Czaja, TRC
c          - In IMORE option (additional analysis), the highest total concentrations
c            when the selected source group contribute significanlty
c            can not be a Rank 1 of the total concentrations but at the highest 
c            a rank 2: H2H.
c          - If first group is starting with "all", the total = all source + background
c            is compared to threshold, otherwise, the first group is compared to threshold.
c          - An error was corrected for the scratch file for complex receptor.
c            it was called iox2 - has been changed to iox3.
c            (changes can be found cec-(070813))
c --- Version 6.23, level 070424 to version 6.24, level 070425
c --- Changes C. Escoffier-Czaja, TRC
c          - A correction has been made for reading the CALPUFF files with 
c            gridded receptors - subroutine GETRCRD modified
c          - Modification in the storing of data in scratch file to make the code 
c            work for big arrays
c          - The scratch files are Direct Access Files.
c --- Version 6.22, level 070416 to version 6.23, level 070424
c --- Changes C. Escoffier-Czaja, TRC
c          - Instead of processing all receptors of CALPOST output rank
c            file, only the one with highest rank larger than thresh_lim
c            will be processed.  
c          - An array of 1, 0 is recorded to determine the list of receptors
c            in CALPOST output rank file, which can be different than the total
c            receptors processed in CALPUFF.
c            if 1, receptor will be used for the process of highest total
c            concentration when sources selected is larger than thresh_lim2
c          - Change in initialization of igrd, idisrec,itrnrec - all set to 0
c          - Change in mltbound - igrd, idisrec, itrnrec are set to 1 only 
c            if receptor is selected.
c          - Add subroutine SAVEHEAD and TESTHEAD from POSTUTIL to check the 
c            CALPUFF files are compatibles
c          - Add some checks to stop the runs if time step is smaller than 3600sec
c          - Add some chekcs to stop the runs if user wants to process individual 
c            sources - only total concentration (all sources) can be processed
c --- Version 6.21, level 070403 to version 6.22, level 070416
c --- Changes C. Escoffier-Czaja, TRC
c          - Correct an error for imore option = 1, all the receptors
c            of CALPOST output rank file need to be processed, not the one
c            only with a highest rank larger than thresh_lim
c --- Version 6.2, level 070321 to version 6.21, level 070403
c --- Changes C. Escoffier-Czaja, TRC
c          - Add a summary at the end of the output file, giving the maximum for
c            each group of source + all the other contributions as well.
c          - Add possibility to enter .lst file name
c          - Add a choice to look for the period (if any) with the maximum total concentration
c            when a selected group of source is larger than a specific second threshold 
c           (for instance the SIL of this period)
c --- Version 6.12, level 061012 to version 6.2, level 070321 
c --- Changes C. Escoffier-Czaja, TRC
c          - Read the list of receptors from a separate file (two formats available)
c          - Make the output files record only total concentration larger than
c            a certain threshold.
c          - All ranked concentration for each receptor are recorded in the same file
c          - Choice to print out or not the julian day time series at each receptor
c          - Modification of the output format
c          - Modification of the control input file as well
c --- Version 6.11, level 061003 to version 6.12, level 061012
c --- Changes C. Escoffier-Czaja, TRC
c         - make the run stop at the end of the the number of hours to process
c           (see CEC - 061012) 
c --- Version 6.1, level 060925  to version 6.11 level 061003
c --- Changes by Francoise Robe, TRC
c         - Transfer parameters (maxfile,maxday,.maxhr,maxtot) from main code 
c           to params.ans and replace maxday*maxhr by maxtot in dimensions 
c           external file
c         - Updated write formats to write up to 50 contributions
c           in one row (instead of only 30 sources). This facilitates
c           reading the output by other programs (e.g. PERL script to 
c           make .csv tables)
c
c --- Version 6.0, level 050914  to version 6.1 level 060925
c --- Changes by Christopher DesAutels, TRC
c         - Updated subroutines GETHEAD from CALPOST Version: 5.6393
c            Level: 060202 to read new CALPUFF header  
c         - changed calls for unit 'in1' to 'io' i GETHEAD
c         - changed reference for mavg to mavgpd in MAIN
c           with version 2.1 dataset mavgpd is read not mavg.  Routines
c           already transfer mavg value to mavgpd for earlier datasets.
c         - changed output format to f13.8 instead of 13.4 to increase accuracy 
c           (and consistency with CALPOST)
c         - change maxfile from 24 to 50
c
c --- Version 5.1, level 030513 to version 6.0, level 050914
c     Changes by Christelle Escoffier-Czaja, Earth Tech.
c            additional modification were performed to reflect some update
c            in the header of CALPUFF concentration files.
c            the subroutine GETHEAD and GETDOC were copied and pasted
c            from CALPOST version 5.633, level 041202.
c            Averaged period of 1h, 3h, 8h, 24h and more than 24h
c            can be computed (monthly and seasonally).
c            A list of receptor can be selected in the control input file
c            2 files per receptors will be created for the selected period.
c
c --- Version 5.0, level 980515 to Version 5.1, level 030513
c             Christelle Escoffier-Czaja, Earth Tech.
c             This program has been modified in May, 2003 to make it
c             works properly for 1h, 3h and 8h averaged.
c
c-----------------------------------------------------------------------
c     Original version by Shuming Du , Earth Tech, 11/18/1998
c-----------------------------------------------------------------------
c
c
c  ARGUMENTS:   none
c
c  CALLING ROUTINES:    none
c
c  EXTERNAL ROUTINES:   GETRCRD,SUMCONC, AVGCONC,
c                       RESET, SUNIT,SCALE, GETHEAD, GETDOC, DATETM
c
c --- COMMON BLOCK VARIABLES USED:
c                /QA/ Common Block
c                rcpu, rdate, rtime
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'head.ans'
      INCLUDE 'conc.ans'
      INCLUDE 'filnam.ans'
      INCLUDE 'qa.ans'
c
c --- Local arrays and parameters
c --- parameters transferred to params.ans (061003- FRR)
c     parameter(maxfile=50,maxday = 732,maxhr=24, maxday*maxhr=maxtot)
      CHARACTER*3 namcp
      CHARACTER*4 codever
      CHARACTER*6 codelevel
      CHARACTER*5 fl,fl_max(maxfile)
      CHARACTER*7 fl_max2
      Character*30 ihead
      Character*7 aunit
      character*22 buffer
      Character*13 asrcname(maxfile)
      character*16 asrcnametemp(maxfile)
      Character*132 ipath1,ipath(maxfile),listout
      CHARACTER*132 ajulout,aconout,buff,arecpt
      Character*1 llra
      Character*1 cstore1(15)
c
      Real cmax(maxfile,maxtot)
      Real xmax(maxtot)
      Real ymax(maxtot)
      Real crank(maxfile,maxtot)
      Real xrank(maxtot)
      Real yrank(maxtot)
      Real total(maxtot),tlrank(maxtot),othsrc(maxtot),othrank(maxtot)
      real xmaxval(maxfile),xrankmax(maxfile),yrankmax(maxfile)
      real crankmax(maxfile,maxfile),tlrankmax(maxfile)
      real othrankmax(maxfile)
      real xmaxval2,xrankmax2,yrankmax2,othrankmax2
      real crankmax2(maxfile),crankmax1(maxfile),tlrankmax2
      Real cviok(maxfile,maxtot),tlviok(maxtot),othviok(maxtot)
      Real xviok(maxtot)
      Real yviok(maxtot)
c
      real xb1(maxalrec),yb1(maxalrec),xval1(maxalrec)
      integer igrd1(mxgx,mxgy),idisrec1(mxdrec),itrnrec1(mxctrec)
      integer irk_1(maxalrec)
      integer ireceptID,nhour_rank
      integer ifrmt
c
      real cmin,xxmax,thresh_lim, thresh_lim2
      Integer juliandy(maxtot),hour11(maxtot)
      Integer ihour(maxtot),idayy(maxtot)
      Integer namyr(maxtot)
      Integer namdy(maxtot),namyr1(maxtot)
      Integer iidum,ippp,cnt,cntper,nnrcp
      Integer imaxyr(maxfile),imaxjul(maxfile),imaxhr(maxfile)
      Integer Indrank(maxfile)
      Integer imaxyr2,imaxjul2,imaxhr2
      Integer nipt1,nipt2
      Integer iviok(maxtot)
c
c --- (CEC - 071022) Logical - Rank 1 or not for imore option
      Logical lrank

c --- Key Variables (KEY_CODE)
      character*132 keyfile
      logical lunlocked

c --- To write out trimmed and left-justified strings
      character*8 ablnk8,achar8,achar8b

c --- To write out time as '(YYYY,DDD,HH00)'
      character*4 atime0
      character*3 atime1
      character*2 atime2
      character*15 astime,aetime,ablnktime,aviotime(maxtot)

c --- Set data block
      data ablnk8/'        '/
      data ablnktime/'(    ,   ,  00)'/

c --- String for reporting QA issues
      character*132 halt132

c  Declare logical
c      logical LSGRID,LCOMPRS
c --- End of local parameters/arrays

c  Declare arrays not passed in common
      INCLUDE 'arrays.ans'


c --- Set version and level numbers
        codever='6.40'
        codelevel='110415'


c --- Get date and time from system
      call DATETM(rdate,rtime,rcpu)
c
c --- Initialization 
        xb=-999.
        yb=-999.
	thresh_lim=-999.
        thresh_lim2=-999.
C - icount, total number of exceedances; ict_rec, number of receptors processed
C - ict_excd, number of receptors with exceedances
C - iviola, number of violation (total > thresh_lim and facility > thresh_lim2
	icount=0                                                         
        ict_rec=0    
        ict_rec2=0                                                    
        ict_excd=0  
        iviola=0
c --- initialization - receptors arrays
        do i=1,maxalrec
        xb1(i)=-999
        yb1(i)=-999
        xval1(i)=-999
        enddo
c
c --- Initialization - all arrays 
        do i=1,maxtot
        namyr(i)=0
        namdy(i)=0
        ihour(i)=0
        xmax(i)=0.
        ymax(i)=0.
        total(i)=0.
        othsrc(i)=0.
        tlrank(i)=0.
        othrank(i)=0.
        xrank(i)=0.
        yrank(i)=0.
        juliandy(i)=0
        hour11(i)=0
        namyr1(i)=0
        xviok(i)=0.
        yviok(i)=0.
        tlviok(i)=0.
        othviok(i)=0.
          do j=1,maxfile
          cmax(j,i)=0.
          crank(j,i)=0.
          cviok(j,i)=0.
          enddo
        enddo
c          
c --- logical initialization
        lrank=.FALSE.
c     KEY_CODE
        lunlocked=.FALSE.
c
c --- Initialize problem string
      halt132(1:18)='NORMAL TERMINATION'
      do i=19,132
         halt132(i:i)=' '
      enddo

c  Get the name of the control file from the command line
      call comline(pstinp)
c
c  Open the control file
      open(in2,file=pstinp,status='old')
      read(in2,901)ihead,listout
c
c ---------------------------------------------
c --- Write input info back to output list file
c ---------------------------------------------
c  Open the list file
      open(iolst,file=listout,status='unknown')

c --- Check version code and version in parameter file
        if(codever.ne.mver.or.codelevel.ne.mlevel) then
        write(iolst,*)' '
        write(iolst,*)'ERROR - VERSION IN PARAMS.ANS AND CODE DIFFERS' 
        write(iolst,*)'-----------------'
        write(iolst,*)'IN CODE - VERSION ',codever,' LEVEL ',codelevel
        write(iolst,*)'IN PARAMS - VERSION ',mver,' LEVEL ',mlevel
        halt132(1:48)='ERROR - VERSION IN PARAMS.ANS AND CODE DIFFERS'
        do i=49,132
           halt132(i:i)=' '
        enddo
        goto 1001
        endif
c --- Write banner to list file
      write(iolst,5) codever,codelevel
5     format(/,23x,'CALANALYSIS OUTPUT SUMMARY',/,19x,'VERSION: ',A5,
     1       '      LEVEL: ',A7///)
c
c --- Read the name of the species concerned
      read(in2,905) ihead,asplvanl
c
c --- (CEC - 090227 - convert species name in CAPITAL letters)
c ---    Convert characters to upper case
         do j=1,15
            cstore1(j)=asplvanl(j:j)
         enddo
         call ALLCAP(cstore1,15)
         do j=1,15
            asplvanl(j:j)=cstore1(j)
         enddo
c
c --- Read starting time and date 
      read(in2,906) ihead,isyr,ismo,isdy,ishr
      issec=0000
      call JULDAY(iolst,isyr,ismo,isdy,jsday,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
c 
c --- Read number of calpuff period (number of hours) to process
      READ(in2,911) ihead,nper
c
c --- Read in the number of input data files
      read(in2,906) ihead,nipt
c
c --- (CEC - 090227) Add a check against the maximum number of files allowed
      if(nipt.gt.maxfile) then
      write(iolst,*)'ERROR - MAXIMUM NUMBER OF FILES ALLOWED ',maxfile
      write(iolst,*)' NUMBER OF FILES PROVIDED ',nipt
      halt132(1:50)='ERROR-NUMBER OF FILES PROVIDED LARGER THAN MAXFILE'
      do i=51,132
        halt132(i:i)=' '
      enddo
      goto 1001
      endif
c
c --- nipt1 is needed for total - additional array computed
      nipt1=nipt+1
c --- nipt2 is needed for other source array - additional array also computed
      nipt2=nipt+2
c
c --- Initialization of xmaxval2 (used to find maximum concentration) 
c --- and xmaxval (used to find the maximum over all for each source)
c --- (CEC) -080111 - xmaxval2 change from 0.0 to -99999.
c --- (CEC) - 080502 - jj=1,nipt1 changed to jj=1,nipt2
        xmaxval2=-99999.
        do jj=1,nipt2
        xmaxval(jj)=-99999.
        enddo
c
c --- read the concentration data files
      do ifile=1,nipt
        Read(in2,901)ihead,ipath(ifile)
        Read(in2,902)ihead,asrcname(ifile)
c ---   Add 3 spaces to end of source names for writing out later to LST file
        asrcnametemp(ifile)(1:13)=asrcname(ifile)(1:13)
        asrcnametemp(ifile)(14:16)='   '
      enddo

c --- Read in concentration output scaling factors a & b
      read(in2,913)ihead,a,b
c
c --- Set LSCALE 
      if(a.ne.0.0.or.b.ne.0.0) then
         LSCALE = .TRUE.
      endif
c --- Unit definition
      if(a.eq.1.0) then 
        aunit ='g/m**3 '
      elseif(a.eq.1.0e3) then
        aunit ='mg/m**3'
      elseif(a.eq.1.0e6) then
        aunit ='ug/m**3'
      else
        halt132(1:30)='Error in units scale factor   '
        do i=31,132
           halt132(i:i)=' '
        enddo
        goto 1001
      endif
c
c --- Read in background concentration
      read(in2,908) ihead,backgrnc

c --- Read in the averaging time (in hour)
      read(in2,906) ihead,nhour
c
c --- (CEC - 071022) Define number of hours when Rank 2 can not exist
      nhalf=int(nper/nhour)
c
c --- initializing the date
      namdy0=jsday
      namyr0=isyr
c
c ---    Convert end-time of first hour processed to begin-time (begining time read from calanalysis.inp)
c ---    Not necessary to be done
c         call INCR(iolst,isyr,jsday,ishr,-1,halt132)
c         if(halt132(1:6) .NE. 'NORMAL') goto 1001
c         call GRDAY(iolst,isyr,jsday,ismo,isdy,halt132)
c         if(halt132(1:6) .NE. 'NORMAL') goto 1001
c
c --- Read the threshold up to which the values will be output in the sorted file
      read(in2,908)ihead,thresh_lim
c
c --- Read receptor list from an output file or in the control file
c --- arecpt = rank 1 CALPOST output for all sources + background
      READ(in2,911) ihead,ifrmt
      READ(in2,912)ihead,arecpt
c      write(*,*)arecpt
c
      open(in4,file=arecpt,status='old')
C
      if(ifrmt.eq.0) then
      read(in4,'(a22)')buffer
      if (buffer(4:9).eq.'RANKED')then
      read(buffer(11:15),'(i5)')nhour_rank
      else
      read(buffer(4:9),'(i6)')nhour_rank
      endif
c --- CEC - 080110 - make code stop if Rank file output of CALPOST is not same averaging period as requested in control input file
      if(nhour_rank.ne.nhour) then
c --- IWL - 080114: Send screen output to list file instead and to halt132, remove stop
      write(iolst,*)'ERROR - RANK FILE READ NOT SAME AVERAGING ',
     &              'PERIOD '
      write(iolst,*)'AS IN CALANALYSIS.INP'
      write(iolst,*)nhour,' IS READ IN CALANALYSIS.INP'
      write(iolst,*)nhour_rank,' IS READ IN CALPOST RANK FILE'
      halt132(1:48)='ERROR - RANK FILE READ NOT SAME AVERAGING PERIOD'
      do i=49,132
        halt132(i:i)=' '
      enddo
      goto 1001
      endif
      do i=1,5
      read(in4,*)
      enddo
c
c --- CEC - 080418 - Test CALPOST Rank Header to make sure it is a Ranked output file.
c --- Make code stop if not.
      elseif(ifrmt.eq.2) then
      read(in4,'(a22)')buffer
      if (buffer(4:9).ne.'RANKED')then
      write(iolst,*)'ERROR - RECEPTOR FILE READ NOT CALPOST RANKED ',
     &                'FILE'
      write(iolst,*)' RANKED FILE MUST BE CREATED WITH AVERAGING ',
     &                'PERIOD'
      write(iolst,*)' SMALLER THAN CALPUFF RUN LENGTH'
      halt132(1:47)='ERROR - RECEPTOR FILE NOT A CALPOST RANKED FILE'
      do i=48,132
        halt132(i:i)=' '
      enddo
      goto 1001
      endif
      do i=1,5
      read(in4,*)
      enddo
      endif
      ir=1

c --- (CEC - 080305 - only for receptors read from CALPOST outputs)
c --- Read the total list of receptor - to be processed + rank1 of allsource+ background
c --- And record the x,y,xval rank1 values - will be checked against if imore=1
502    continue
       if(ifrmt.eq.0) then
       read(in4,*,end=503)xb1(ir),yb1(ir),xval1(ir)
       ir=ir+1
       else
       read(in4,*,end=503)xb1(ir),yb1(ir)
       ir=ir+1
       endif
       goto 502
c
503	rewind(in4)
        if(ifrmt.eq.0.or.ifrmt.eq.2) then
        do i=1,6
	read(in4,*)
        enddo
        endif
c
c --- Read information for more analysis if requested
c --- thresh_lim2 (second threshold for more analysis)
c --- isrcgp = source group number in the list selected.
      READ(in2,911)ihead,imore
      read(in2,908)ihead,thresh_lim2
      read(in2,911)ihead,isrcgp
c --- Lrank logical for using Rank 1 or not when imore=1
      read(in2,914)llra
       if(llra.eq.'T')lrank=.TRUE.
       if(llra.eq.'F')lrank=.FALSE.
c      
c --- Read base name for output files time series if requested
      READ(in2,911)ihead,iouttime
      if(iouttime.eq.1) then
      READ(in2,912)ihead,buff
         nt=index(buff,' ')
      endif
c

c --- KEY_CODE - Begin

c --- Read key path/filename from control file
      Read(in2,901)ihead,keyfile

c --- Open key file, read key, close key file
      open(iokey,file=keyfile,status='old')
      read(iokey,'(i10)')ikeyin
      close(iokey)

c --- Check key against master key
c      if(ikeyin.eq.1813501746) then
        lunlocked=.TRUE.

c --- Else check key against computed key
c      else
c        call keycalc(pstinp,in2,ikeycalc1)
c        if(ikeyin.eq.ikeycalc1) then
c          lunlocked=.TRUE.
c        endif
c      endif

c --- If key is confirmed then proceed, otherwise halt the code
      if(.NOT.lunlocked) then
        halt132(1:23)='ERROR - CODE IS LOCKED'
        do i=23,132
           halt132(i:i)=' '
        enddo
        goto 1001
      endif

c --- KEY_CODE - End

c
c --- Initialisation total number of receptors in CALPOST output file format read by CALANALYSIS (arecpt - ifrmt=0)
        ircp=0
c
c --- Write summary of inputs to list file
      write(iolst,*)'SUMMARY OF INPUTS:'
      write(iolst,*)'------------------'
      write(iolst,*)
      write(iolst,*)'                       Species :  ',
     &  TRIM(asplvanl)
      write(iolst,*)
      write(iolst,*)'              Averaging Period : ',nhour, 'hrs'
      write(iolst,*)

c --- Write threshold limit 1 into string
      achar8=ablnk8
      write(achar8,'(f8.2)') thresh_lim

c --- Left justify and trim the threshold limit strings
      if(imore.eq.0) then
        write(iolst,*)'               Threshold Limit : ',
     &    TRIM(ADJUSTL(achar8)),' ',aunit
      else
        write(iolst,*)'             Threshold Limit 1 :  ',
     &    TRIM(ADJUSTL(achar8)),' ',aunit
        write(iolst,*)

c ---   Write threshold limit 2 into string
        achar8=ablnk8
        write(achar8,'(f8.2)') thresh_lim2
        write(iolst,*)'             Threshold Limit 2 :  ',
     &    TRIM(ADJUSTL(achar8)),' ',aunit
      endif
      write(iolst,*)

c --- Write ambient bckg conc into string
      achar8=ablnk8
      write(achar8,'(f8.2)') backgrnc
      write(iolst,*)'             Ambient Bckg Conc :  ',
     &    TRIM(ADJUSTL(achar8)),' ',aunit
      write(iolst,*)
      do ifile=1,nipt
        write(iolst,*)'         Concentration File ',ifile,':  ',
     &    TRIM(ipath(ifile))
        write(iolst,*)'             Source Group Name :  ',
     &    '[',TRIM(asrcname(ifile)),']'
        write(iolst,*)
      enddo

c --- Write input receptors data file
      write(iolst,*)'           Receptors Data File :  ',
     &  TRIM(ADJUSTL(arecpt))
      write(iolst,*)

c --- Write number of receptors processed as string
      write(achar8,'(i8)') ir-1
      write(iolst,*)' Number of Receptors Processed :  ',
     &  TRIM(ADJUSTL(achar8))
      write(iolst,*)
c
c --- Compute end time
      ieyr=isyr
      jeday=jsday
      iehr=ishr
      call INCR(iolst,ieyr,jeday,iehr,nper,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
c
c --- Write out period processed
      write(atime0,'(i4.4)') isyr
      write(atime1,'(i3.3)') jsday
      write(atime2,'(i2.2)') ishr
      astime=ablnktime
      astime(2:5)=atime0(1:4)
      astime(7:9)=atime1(1:3)
      astime(11:12)=atime2(1:2)
      aetime=ablnktime
      write(atime0,'(i4.4)') ieyr
      write(atime1,'(i3.3)') jeday
      write(atime2,'(i2.2)') iehr
      aetime(2:5)=atime0(1:4)
      aetime(7:9)=atime1(1:3)
      aetime(11:12)=atime2(1:2)
      write(iolst,*)'              Period Processed :  ',astime,' to ',
     &  aetime
      write(iolst,*)
      write(iolst,*)
c
c --- Make loop over number of receptors to processed
500    continue
       if(ifrmt.eq.0) then
       read(in4,*,end=501)xb,yb,xval
       ircp=ircp+1
       ii1=int(ircp/10000)
       fl(1:1)=achar(ii1+48)
       ii1=int(ircp-ii1*10000)
       ii2=int(ii1/1000)
       fl(2:2)=achar(ii2+48)
       ii2=int(ii1-ii2*1000)
       ii3=int(ii2/100)
       fl(3:3)=achar(ii3+48)
       ii3=int(ii2-ii3*100)
       ii4=int(ii3/10)
       fl(4:4)=achar(ii4+48)
       ii5=int(ii3-ii4*10)
       fl(5:5)=achar(ii5+48)
c
c --- Only receptors above a certain threshold are processed.
       if (xval.lt.thresh_lim) then
       goto 500
       endif
       ict_rec=ict_rec+1
c
       elseif(ifrmt.eq.2.or.ifrmt.eq.1) then
c --- (CEC - 080418)
c --- if CALPOST Rank file output is chosen and choice that all receptors in the list are used
c --- need to make sure it is a Rank file, though - to skip the header
c --- OR if other format (non CALPOST output) is chosen  - all receptors in the list are used
c       
       read(in4,*,end=501)xb,yb
       ict_rec=ict_rec+1
       ii1=int(ict_rec/10000)
       fl(1:1)=achar(ii1+48)
       ii1=int(ict_rec-ii1*10000)
       ii2=int(ii1/1000)
       fl(2:2)=achar(ii2+48)
       ii2=int(ii1-ii2*1000)
       ii3=int(ii2/100)
       fl(3:3)=achar(ii3+48)
       ii3=int(ii2-ii3*100)
       ii4=int(ii3/10)
       fl(4:4)=achar(ii4+48)
       ii5=int(ii3-ii4*10)
       fl(5:5)=achar(ii5+48)
c
       else
       write(iolst,*)'ERROR - WRONG RECEPTOR LIST FORMAT - 0,1 or 2 ',
     &               'only '
       write(iolst,*)ifrmt,' IS READ IN CALANALYSIS.INP'
       halt132(1:48)='ERROR, WRONG RECEPTOR LIST FORMAT, 0,1 or 2 only'
       do i=49,132
         halt132(i:i)=' '
       enddo
       goto 1001
       endif
c
c - if option to create time series is chosen
           if(iouttime.eq.1) then
           nt2=nt+5
           buff(nt:nt2)=fl(1:5)
           ntt=INDEX(buff,' ')-1
           ajulout=buff(1:ntt)//'.day'
c           aconout=buff(1:ntt)//'.con'
           endif
c
       xmax1=xb
       ymax1=yb
       concmax=-999.
       do i=1,maxtot
       total(i)=0.
       end do
c
c      ioo1 = 31 - cec changed on April 21, 2003
c --- conflict in file numbering
      if(iouttime.eq.1) then
c --- (CEC - 080131) - ioo1 change to 17 and put in params.ans file
c      ioo1 = 71
      Open(ioo1,file=ajulout,status='unknown')
      write(ioo1,*)'CALANALYSIS Version/Level: ',codever,'/',codelevel
      endif
c
c --- (CEC - 080131) - Remove Error message if maxfile is larger than 50.
c ---  All input file open ID number beside CALPUFF input files are below 20
c      if(maxfile.gt.50) then
c        halt132(1:41)='ERROR - Maxfile can not be larger than 50'
c        do i=42,132
c           halt132(i:i)=' '
c        enddo
c        goto 1001
c      endif
c
 901  Format(a30,a132)
 902  Format(a30,a13)
 905  Format(a30,a15)
 906  Format(a30,i4,1x,i2,1x,i2,1x,i2)

c --- Ambient Bckg. Conc. and Threshold Limits 1 & 2
c      For READ in
 908  Format(a30,f8.0)
c      For WRITE out
 907  Format(a30,f8.2)

c --- Scaling Factors a & b
c      For READ in
 913  Format(a30,f9.0,1x,f3.0)
c      For WRITE out
 909  Format(a30,f9.1,1x,f3.1)

 910  Format(a30,f8.3,1x,f9.3,1x,a5)
 911  FORMAT(a30,i4)
 912  FORMAT(a30,a132)
 914  FORMAT(a31,a1)
c
c --- loop over all input data files
c --- open the concentration data files
505   do ifile=1,nipt
      inn1=20+ifile
      Open(inn1,file=ipath(ifile),status='old',form='unformatted')
c
c  Obtain specifications for modeled concentrations (/head/)
      call GETHEAD(inn1,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
      if(ifile.EQ.1) then
c ---    Place information in /head0/ for testing
         call SAVEHEAD
      else
c ---    Compare with information in /head0/
         call TESTHEAD(halt132)
         if(halt132(1:6) .NE. 'NORMAL') goto 1001
      endif
c
c --- Open scratch file for storing arrays - one file for each type of receptor
c --- Necessary only if option imore =1.
      if(ifile.eq.1.and.imore.eq.1.and.ict_rec.le.1) then
       if(LSGRID)then
       irec1=0
       OPEN(iox1,status='scratch',access='direct',form='formatted',
     & recl=20)
       endif
       if(ndrec.gt.0)then
       irec2=0
       open(iox2,status='scratch',access='direct',form='formatted',
     & recl=20)
       endif
       IF(LCTSG)then
       irec3=0
       open(iox3,status='scratch',access='direct',form='formatted',
     & recl=20)
       endif
      endif
c
c --- Stop the runs if individual sources need to be process - only TOTAL can be processed
      if(isrcindv.eq.1) then
        halt132(1:47)='CAN NOT PROCESS INDIVIDUAL SOURCES - ONLY TOTAL'
        do i=48,132
           halt132(i:i)=' '
        enddo
        goto 1001
      endif
c --- Stop the runs if time step is smaller than 1 hour = 3600 seconds
      if(nsecdt.lt.3600) then
        halt132(1:43)='CAN NOT PROCESS TIME STEP SMALLER THAN 1 HR'
        do i=44,132
           halt132(i:i)=' '
        enddo
        goto 1001
      endif
c
c  Set minimum dimensions of concentration arrays (for reads in GETRCRD)
      idimx=MAX(1,ngx)
      idimy=MAX(1,ngy)
      idimd=MAX(1,ndrec)
      idimt=MAX(1,nctrec)
c
c --- Only need to do this once  - Select all receptors listed in CALPOST output file read by CALANALYSIS
      if(ifence.eq.0.and.ifile.eq.1) then
         do i=1,idimx
         do j=1,idimy
           igrd1(i,j)  = 0
         enddo
         enddo
         do i = 1, idimd
           idisrec1(i) = 0
         enddo
         do i = 1, idimt
           itrnrec1(i) = 0
         enddo
         do i=1,ir-1
           xb2=xb1(i)
           yb2=yb1(i)
           call mltbound(xb2,yb2,jfence,idimx,idimy,idimd,idimt,
     &                   xgrd,ygrd,xrec,yrec,xctr,yctr,igrd1,idisrec1,
     &                   itrnrec1,halt132)
         enddo
         ifence = 1
      endif
c --- Set all elements of indicator arrays to be zero - receptors with concentration > thresh_lim need to be selected
      do i=1,idimx
      do j=1,idimy
         igrd(i,j)  = 0
      enddo
      enddo
      do i = 1, idimd
         idisrec(i) = 0
      enddo
      do i = 1, idimt
         itrnrec(i) = 0
      enddo
c --- Need to be done for every receptor
      call mltbound(xb,yb,jfence,idimx,idimy,idimd,idimt,
     &              xgrd,ygrd,xrec,yrec,xctr,yctr,igrd,idisrec,
     &              itrnrec,halt132)
c
c -- Find number of hours between start of data and processing start
      call DELTT(msyr,mjsday,mshr,isyr,jsday,ishr,idelhr)
      delhr=FLOAT(idelhr)+FLOAT(issec-mssec)/3600.
c -- Length of averaging period in hours in CALPUFF concentration file
      avghr=FLOAT(nsecdt*mavgpd)/3600.
c -- Find number of averaging periods between start of data and processing start
      aper=delhr/avghr
      naper=NINT(aper)
c -- Number of period in the run (in CALPUFF concentration file)
      mnper= mnrun/mavgpd
c -- Length of interval (delhr) should be product of avg. time * # per,
c -- to the nearest second (.0002778 hour)
      ifatal=0
      if(ABS(naper*avghr-delhr).GT.0.0003) then
        write(iolst,*)
        write(iolst,*)'**************    FATAL    ***************'
        write(iolst,*)'Start time is fractional number of averaging',
     &              ' periods from start of model data!'
        write(iolst,*)'NPER= ',naper,' AVGHR= ',avghr,' DELHR= ',delhr
        ifatal=1
      endif
      if(naper .LT. 0) then
        write(iolst,*)
        write(iolst,*)'**************    FATAL    ***************'
        write(iolst,*)'Start time preceeds beginning of data!'
        write(iolst,*)'NAPER = ',naper
        ifatal=1
      endif
c -- Check for number of periods to process
      if(nper .GT. mnper) then
        write(iolst,*)
        write(iolst,*)'**************    FATAL    ***************'
        write(iolst,*)'Number processing periods exceeds data periods!'
        write(iolst,*)'NPER = ',nper,' MNPER = ',mnper
        ifatal=1
      endif
c -- Check ending hour in control file
      if(nper+naper .GT. mnper) then
        write(iolst,*)
        write(iolst,*)'**************    FATAL    ***************'
        write(iolst,*)'End time extends beyond data!'
        write(iolst,*)'NPER = ',nper,' NAPER = ',naper,' MNPER = ',
     &                 mnper
        ifatal=1
      endif
      nskip=naper

c --- Terminate now if problem was found
      if(ifatal.EQ.1) then
        halt132(1:42)='Invalid time period found -- See list file'
        do k=43,132
          halt132(k:k)=' '
        enddo
        goto 1001
      endif

c
c  Skip to starting hour for processing concentrations (/conc/)
      if(isyr .NE. msyr .OR. jsday .NE. mjsday .OR.
     *   ishr .NE. mshr .OR. issec .NE. mssec) then
c
         do i=1,nskip
            call SKIPREC(inn1,tcg,tcd,tct,idimx,idimy,idimd,idimt,ieof,
     &                   halt132)
            if(halt132(1:6) .NE. 'NORMAL') goto 1001
            if(ieof.EQ.1) then
               write(halt132(1:51),'(a39,i12)')
     &           'End Of File found when skipping period ',i
               do k=52,132
                 halt132(k:k)=' '
               enddo
               goto 1001
            endif
         enddo
      endif
c
c  Initialize period counter (iper)
      iper=0
      ieof=0
      cntper=0
c
c  Compute number of periods to process
c  [MXPER_FIX]
c      mxper=mnhrs/mavgpd
      mxper=nper-mod(nper,nhour)
c
c  Loop over concentration averaging periods --------------------------
 10    iper=iper+1
c
c --- Read concentrations
c
         call GETRCRD(inn1,iolst,tcg,tcd,tct,idimx,idimy,idimd,idimt,
     &                ieof,halt132)
         if(halt132(1:6) .NE. 'NORMAL') goto 1001
         if(ieof.EQ.1) then
            mxper=iper-1
            goto 11
         endif
c
c  Apply user-specified scaling (if required) in internal CALPUFF
c  units (g/m**3 for concentration)
      if(LSCALE) call SCALE
c
c  Section for 24*mavg -hr concentrations
      if(nhour.eq.24) then
         call SUMCONC(av24cg,av24cd,av24ct,av24bg,av24bd,av24bt,
     *                av24hg,av24hd,av24ht)
         if(MOD(iper,24) .EQ. 0) then
            call AVGCONC(24,av24cg,av24cd,av24ct,av24bg,av24bd,av24bt,
     *                      av24hg,av24hd,av24ht)
c
c --- Find the highest concentration for the first concentration file listed
c
            if(ifile.eq.1) then
            ihour1=mhre
            cntper=cntper+1
            namyr(cntper)=myre
	    namdy(cntper)=mjdaye
              concmax = 0.0
              if(LSGRID)then
                do i=1,ngx
                  do j=1,ngy
                     if(ict_rec.le.1.and.imore.eq.1) then
                     irec1=irec1+1
                     write(iox1,100,rec=irec1)av24cg(i,j)*igrd1(i,j)
                     endif
                     tempcon = av24cg(i,j)*igrd(i,j)
                     if(tempcon.gt.concmax) then
                        concmax = tempcon
                        xmax1 = xgrd(i,j)
                        ymax1 = ygrd(i,j)
                     endif
                  enddo
                enddo
              endif
              if(ndrec.gt.0)then
                do i=1,ndrec
                  if(ict_rec.le.1.and.imore.eq.1) then
                  irec2=irec2+1
                  write(iox2,100,rec=irec2)av24cd(i)*idisrec1(i)
                  endif
                  tempcon = av24cd(i)*idisrec(i)
                  if(tempcon.gt.concmax) then
                    concmax = tempcon
                    xmax1 = xrec(i)
                    ymax1 = yrec(i)
                  endif
                enddo
              endif
c              if(nctrec.gt.0)then
               IF(LCTSG)then
                do i=1,nctrec
                  if(ict_rec.le.1.and.imore.eq.1) then
                  irec3=irec3+1
c --- cec-(070813) - ERROR FIXED - iox1 change to iox3 for complex receptor
c                 write(iox2,100,rec=irec3)av24ct(i)*itrnrec1(i)
                  write(iox3,100,rec=irec3)av24ct(i)*itrnrec1(i)
                  endif
                  tempcon = av24ct(i)*itrnrec(i)
                  if(tempcon.gt.concmax) then
                    concmax = tempcon
                    xmax1 = xctr(i)
                    ymax1 = yctr(i)
                  endif
                enddo
              endif
c
              cmax(ifile,cntper) = concmax
              xmax(cntper) = xmax1
              ymax(cntper) = ymax1
              ihour(cntper) = ihour1
            else
            cntper=cntper+1
  	    cmax(ifile,cntper)=-999
              if(LSGRID)then
                do i=1,ngx
                  do j=1,ngy
                  if(ict_rec.le.1.and.imore.eq.1) then
                  irec1=irec1+1
                  write(iox1,100,rec=irec1)av24cg(i,j)*igrd1(i,j)
                  endif
                  xdifx=abs(xgrd(i,j)-xmax(cntper))
                  ydify=abs(ygrd(i,j)-ymax(cntper))
                    if(xdifx.lt.0.001.and.ydify.lt.0.001) then
                      cmax(ifile,cntper) = av24cg(i,j)
c                      go to 9999
                    endif
                  enddo
                enddo
              endif
              if(ndrec.gt.0)then
                do i=1,ndrec
                if(ict_rec.le.1.and.imore.eq.1) then
                irec2=irec2+1
                write(iox2,100,rec=irec2)av24cd(i)*idisrec1(i)
                endif
                xdifx=abs(xrec(i)-xmax(cntper))
                ydify=abs(yrec(i)-ymax(cntper))
                    if(xdifx.lt.0.001.and.ydify.lt.0.001) then
                      cmax(ifile,cntper) = av24cd(i)
c                      go to 9999
                    endif
                enddo
              endif
c             if(nctrec.gt.0)then
              IF(LCTSG)then
                do i=1,nctrec
                if(ict_rec.le.1.and.imore.eq.1) then
                irec3=irec3+1
                write(iox3,100,rec=irec3)av24ct(i)*itrnrec1(i)
                endif
                xdifx=abs(xctr(i)-xmax(cntper))
                ydify=abs(yctr(i)-ymax(cntper))
                    if(xdifx.lt.0.001.and.ydify.lt.0.001) then
                      cmax(ifile,cntper) = av24ct(i)
c                      go to 9999
                    endif
                enddo
              endif
            endif
 9999       call RESET(av24cg,av24cd,av24ct,av24bg,av24bd,av24bt,
     *                 av24hg,av24hd,av24ht)
         endif
c --- End of 24 hour averaging
      elseif(nhour.ne.24) then
         call SUMCONC(avNcg,avNcd,avNct,avNbg,avNbd,avNbt,
     *                avNhg,avNhd,avNht)
         if(MOD(iper,nhour) .EQ. 0) then
            call AVGCONC(nhour,avNcg,avNcd,avNct,avNbg,avNbd,avNbt,
     *                      avNhg,avNhd,avNht)
c
c --- Find the highest concentration for the first concentration file listed
c
            if(ifile.eq.1) then
            ihour1=mhre
            cntper=cntper+1
            namyr(cntper)=myre
	    namdy(cntper)=mjdaye
            concmax = 0.0
              if(LSGRID)then
                do i=1,ngx
                  do j=1,ngy
                     if(ict_rec.le.1.and.imore.eq.1) then
                     irec1=irec1+1
                     write(iox1,100,rec=irec1)avNcg(i,j)*igrd1(i,j)
                     endif
                     tempcon = avNcg(i,j)*igrd(i,j)
                     if(tempcon.gt.concmax) then
                       concmax = tempcon
                        xmax1 = xgrd(i,j)
                        ymax1 = ygrd(i,j)
                     endif
                  enddo
                enddo
              endif
              if(ndrec.gt.0)then
                do i=1,ndrec
                  if(ict_rec.le.1.and.imore.eq.1) then
                  irec2=irec2+1
                  write(iox2,100,rec=irec2)avNcd(i)*idisrec1(i)
                  endif
                  tempcon = avNcd(i)*idisrec(i)
                  if(tempcon.gt.concmax) then
                    concmax = tempcon
                    xmax1 = xrec(i)
                    ymax1 = yrec(i)
                  endif
                enddo
              endif
c             if(nctrec.gt.0)then
              IF(LCTSG)then
                do i=1,nctrec
                  if(ict_rec.le.1.and.imore.eq.1) then
                  irec3=irec3+1
                  write(iox3,100,rec=irec3)avNct(i)*itrnrec1(i)
                  endif
                  tempcon = avNct(i)*itrnrec(i)
                  if(tempcon.gt.concmax) then
                    concmax = tempcon
                    xmax1 = xctr(i)
                    ymax1 = yctr(i)
                  endif
                enddo
              endif
c
                cmax(1,cntper) = concmax
                xmax(cntper) = xmax1
                ymax(cntper) = ymax1
                ihour(cntper) = ihour1
c
            else
            cntper=cntper+1
            cmax(ifile,cntper)=-999
              if(LSGRID)then
                do i=1,ngx
                  do j=1,ngy
                  if(ict_rec.le.1.and.imore.eq.1) then
                  irec1=irec1+1
                  write(iox1,100,rec=irec1)avNcg(i,j)*igrd1(i,j)
                  endif
                  xdifx=abs(xgrd(i,j)-xmax(cntper))
                  ydify=abs(ygrd(i,j)-ymax(cntper))
                    if(xdifx.lt.0.001.and.mhre.eq.ihour(cntper).and.
     &                  ydify.lt.0.001) then
                      cmax(ifile,cntper) = avNcg(i,j)
c                      go to 9997
                    endif
                  enddo
                enddo
              endif
              if(ndrec.gt.0)then
                do i=1,ndrec
                if(ict_rec.le.1.and.imore.eq.1) then
                irec2=irec2+1
                write(iox2,100,rec=irec2)avNcd(i)*idisrec1(i)
                endif
                xdifx=abs(xrec(i)-xmax(cntper))
                ydify=abs(yrec(i)-ymax(cntper))
                    if(xdifx.lt.0.001.and.mhre.eq.ihour(cntper).and.
     &                  ydify.lt.0.001) then
                      cmax(ifile,cntper) = avNcd(i)
c                      go to 9997
                    endif
                enddo
              endif
c             if(nctrec.gt.0)then
              IF(LCTSG)then
                do i=1,nctrec
                if(ict_rec.le.1.and.imore.eq.1) then
                irec3=irec3+1
                write(iox3,100,rec=irec3)avNct(i)*itrnrec1(i)
                endif
                xdifx=abs(xctr(i)-xmax(cntper))
                ydify=abs(yctr(i)-ymax(cntper))
                    if(xdifx.lt.0.001.and.mhre.eq.ihour(cntper).and.
     &                  ydify.lt.0.001) then
                      cmax(ifile,cntper) = avNct(i)
c                      go to 9997
                    endif
                enddo
              endif
            endif
 9997       call RESET(avNcg,avNcd,avNct,avNbg,avNbd,avNbt,
     *                 avNhg,avNhd,avNht)
         endif
      endif
100	format(f20.10)
c
c --- Next period
c      if(iper.LT.mxper .OR. metrun.EQ.1) 
c --- CEC -061012
c [MXPER_FIX]
c       if(ieof.ne.1.and.iper.lt.nper) goto 10
       if(ieof.ne.1.and.iper.lt.mxper) goto 10
 11    continue
      close(inn1)
      enddo
      

c  ------------------------Exit period loop --------------------------
c --- Calculate Total concentration at the receptor where peak 
c --- concentration due to the key group is achieved.
c --- Here the total C is defined as the sum of concentrations due to all
c --- all sources in the plant concerned and due to sources in other
c --- nearby plants, as well as background C
c
c --- cec(070815) - All the process is done only if at least one receptor is above thres_lim1 or
c                   if receptors are listed in generic file list.
      if(ict_rec.gt.0) then
c
c --- Initialize the other sources array (sources not included in the listed files)
      do iip = 1, cntper
      othsrc(iip)=0.0
      enddo
c
      iall = 0
      do ifile = 1,nipt
        if(asrcname(ifile)(1:3).eq.'ALL'.or.
     &     asrcname(ifile)(1:3).eq.'All'.or.
     &     asrcname(ifile)(1:3).eq.'all') THEN
          iall = ifile
        endif
      enddo
c
c -------- for all averaging period
c     if(nhour.le.24) then
c
      if(iall.eq.0) then
c --- None of the file listed includes all the sources modeled
c
       write(iolst,*)' ' 
       write(iolst,*)'ERROR - ONE OF THE FILE NEEDS TO INCLUDE '
       write(iolst,*)'ALL THE SOURCES MODELED, AND FIRST THREE LETTERS'
       write(iolst,*)'OF THE SOURCE NAME NEED TO BE "ALL".' 
       halt132(1:48)='ERROR - ONE OF THE FILE NEEDS TO INCLUDE ALL SRC'
       do i=49,132
         halt132(i:i)=' '
       enddo
       goto 1001
c
c	do iip = 1, cntper
c          do ifile = 1, nipt
c            total(iip) = total(iip) + cmax(ifile,iip)
c          enddo
c --- other files array can not be computed - so filled with missing
c            othsrc(iip) = -999.99
c
c          if(backgrnc.gt.0.0) then
c            total(iip) = total(iip) + backgrnc
c          endif
c	enddo
c
      elseif(iall.eq.1) then
c --- First file listed includes all the sources modeled
c
	do iip=1,cntper
          do ifile = 2, nipt
            total(iip) = total(iip) + cmax(ifile,iip)
          enddo
c --- Compute the remaining (not listed) background sources (othsrc) total concentration
          difftot=abs(total(iip)-cmax(1,iip))
          if(difftot.gt.0.0001) then
          othsrc(iip)=cmax(1,iip)-total(iip)
          total(iip)=total(iip)+othsrc(iip)
          endif
c
          if(backgrnc.gt.0.0) then
            total(iip) = total(iip) + backgrnc
          endif
	enddo
c
      elseif(iall.eq.nipt) then
c --- Last file listed includes all the sources modeled
c
        niptm1 = nipt - 1
	do iip=1,cntper
          do ifile = 1, niptm1
            total(iip) = total(iip) + cmax(ifile,iip)
          enddo
c --- Compute the remaining (not listed) background sources (othsrc) total concentration
          difftot=abs(total(iip)-cmax(nipt,iip))
          if(difftot.gt.0.0001) then
          othsrc(iip)=cmax(nipt,iip)-total(iip)
          total(iip)=total(iip)+ othsrc(iip)
          endif
c
          if(backgrnc.gt.0.0) then
            total(iip) = total(iip) + backgrnc
          endif
	enddo
c
      else
c --- One file in the middle of the list includes all the sources modeled
        iallm1 = iall - 1
        iallp1 = iall + 1
	do iip=1,cntper
          do ifile = 1, iallm1
            total(iip) = total(iip) + cmax(ifile,iip)
          enddo
          do ifile = iallp1, nipt
            total(iip) = total(iip) + cmax(ifile,iip)
          enddo
c --- Compute the remaining (not listed) background sources (othsrc) total concentration
          difftot=abs(total(iip)-cmax(iall,iip))
          if(difftot.gt.0.0001) then
          othsrc(iip)=cmax(iall,iip)-total(iip)
          total(iip)=total(iip)+othsrc(iip)
          endif
c
          if(backgrnc.gt.0.0) then
            total(iip) = total(iip) + backgrnc
          endif
	enddo
      endif
c
c --- Rank all concentrations and write them out
c --- For averaging time smaller than half the entire period (nhalf > 2)
c
      if(nhalf.ge.2) then
c
c --- 1 - Find the highest concentration for first file listed
	cmin=-99999
	do jjp=1,cntper
            if(cmax(1,jjp).gt.cmin) then
            cmin=cmax(1,jjp)
	    jjpp=jjp
            jjpp1=ihour(jjp)
            jjyr=namyr(jjp)
	    jjdd=namdy(jjp)
            endif
        enddo
c
c --- 2 - Assign the rank 1 concentration for arrays of all files (depending on the results above (1))
        do ifile = 1, nipt
          tlrank(1) = total(jjpp)
          crank(ifile,1) = cmax(ifile,jjpp)
          othrank(1) = othsrc(jjpp)
          xrank(1) = xmax(jjpp)
          yrank(1) = ymax(jjpp)
          juliandy(1) = jjdd
	  hour11(1)=jjpp1
          namyr1(1)=jjyr
        enddo
c
	xxmax=crank(1,1)
c
	do iidum=2,cntper
c
c --- initialization of all ranks below 1
	tlrank(iidum)=0.
        othrank(iidum)=0.
	do ifile=1,nipt
	crank(ifile,iidum)=0.
	enddo
	xrank(iidum)=0.
	yrank(iidum)=0.
        juliandy(iidum)=0
        hour11(iidum)=0
        namyr1(iidum)=0
        jjdd=0
        jjpp=0
        jjpp1=0
        jjyr=0
c
c --- 3 - Find the H2H, then H3H,.... for first file listed		
	cmin=-99999
	do iip=1,cntper
 		if (iip.eq.jjpp) goto 210
		if (cmax(1,iip).lt.xxmax) then
		if (cmax(1,iip).ge.cmin) then
		cmin=cmax(1,iip)
		jjdd=namdy(iip)
		jjpp=iip
                jjpp1=ihour(iip)
                jjyr=namyr(iip)
		endif
		endif
210	enddo
c
c --- 4 - Assign the rank H2H, H3H,... concentration for arrays of all files (depending on the results above (3))
	  tlrank(iidum) = total(jjpp)
	  crank(1,iidum) = cmax(1,jjpp)
          othrank(iidum) = othsrc(jjpp)
   	  do ifile =1, nipt
           crank(ifile,iidum) = cmax(ifile,jjpp)
          enddo
           xrank(iidum) = xmax(jjpp)
          yrank(iidum) = ymax(jjpp)
          juliandy(iidum) = jjdd
	  hour11(iidum) = jjpp1
          namyr1(iidum)=jjyr
	xxmax=crank(1,iidum)
        enddo
c
c --- Header and Data for the output file ranked by Julian Day.
      if(iouttime.eq.1) then
      Write(ioo1,*)'Analysis of CALPUFF modeling results'
      Write(ioo1,218)'For the period: day',namdy0,'/',namyr0,'to day',
     & namdy(cntper),'/',namyr(cntper)
      WRITE(ioo1,217)'At receptor : ',xb,yb
      Write(ioo1,*)'Name of Pollutant:',asplvanl
      Write(ioo1,111)'The key group is:',asrcname(1)
      Write(ioo1,*)'Unit of concentration:',aunit
      Write(ioo1,*)'Averaging time (hour):',nhour
      Write(ioo1,211)'Year J_Day',' period',asrcname(1),'X        '
     & ,'Y        ',(asrcname(ii),ii=2,NIPT),'Background   ',
     &  'Total        '
c
	Do iip = 1,cntper
          Write(ioo1,212)namyr(iip),namdy(iip),ihour(iip),
     &    cmax(1,iip),xmax(iip),
     &    ymax(iip),(cmax(ii,iip),ii=2,NIPT),backgrnc,
     &    total(iip)
        Enddo
      endif
c
c -----------------------------------------------------
c --- count the number of receptors with exceedances
c -----------------------------------------------------
         if(tlrank(1).ge.thresh_lim) then
         ict_excd=ict_excd+1
         endif
c
c -------------------------------------
c --- Write results to output list file
c -------------------------------------
      if (ict_excd.eq.1.and.icount.eq.0) then
c
      write(iolst,*)
      write(iolst,*)'RESULTS:'
      write(iolst,*)'--------'
      write(iolst,*)

c --- Write out ranked results greater than Threshold 1
c --- Write threshold limit 1 into string
      achar8=ablnk8
      write(achar8,'(f8.2)') thresh_lim
c      write(iolst,*)'   RESULTS WHERE TOTAL EXCEEDS [',
c     &  TRIM(ADJUSTL(achar8)),' ',aunit,'] ',
c     &  'RANKED ACCORDING TO SOURCE GROUP [',
c     &  TRIM(ADJUSTL(asrcname(1))),']'
c        write(iolst,*)'   -------------------------------------------',
c     &  '---------------------------------------------------',
c     &  '------------------------------------------'

c --- frr (101112) - write(,*) format splits line in unix
      write(iolst,1007)TRIM(ADJUSTL(achar8)),aunit,
     &                 TRIM(ADJUSTL(asrcname(1)))
      write(iolst,1008)  

      endif

c 1009  format(a32,a8,a1,a7,a36,a11,a1)
c 1010  format(a35,a51,a42)
c ----------------------------------------
c
c --- (CEC - 080201) - Test that the highest rank is equal to the CALPOST Rank 1 values
c ---                  for every receptors
       if(ifrmt.eq.0) then
       do itt=1,ir-1
       xdfx=abs(xb1(itt)-xrank(1))
       xdfy=abs(yb1(itt)-yrank(1))
        if(xdfx.lt.0.001.and.xdfy.lt.0.001) then
        xdfval=abs((tlrank(1)-xval1(itt))/xval1(itt))
         if(xdfval.gt.0.0001) then
c         write(*,*)xdfval,tlrank(1),xval1(itt),xdfx,xdfy,itt
          write(iolst,*)' ' 
          write(iolst,*)'ERROR - THE CALPOST RANK FILE USED DOES NOT'
          write(iolst,*)' MATCH THE CONCENTRATIONS FILES PROVIDED'
          halt132(1:44)='ERROR - THE CALPOST RANK FILE USED DOES NOT'
          halt132(45:83)=' MATCH THE CONCENTRATIONS FILES PROVIDED'
            do i=83,132
               halt132(i:i)=' '
            enddo
            goto 1001
         endif
        endif
       enddo
c --- (CEC - 080305) - Allocate Rank 1 to xval1 when receptors are read from generic file or CALPOST file read as generic file
c ---
       elseif(ifrmt.eq.1.or.ifrmt.eq.2) then
       xdfx=abs(xb1(ict_rec)-xrank(1))
       xdfy=abs(yb1(ict_rec)-yrank(1))
        if(xdfx.lt.0.001.and.xdfy.lt.0.001) then
        xval1(ict_rec)=tlrank(1)
        endif
       endif
c
        Do irrrk = 1, cntper
c --- cec-(070813) - the total (allsrc+bckg) is compared to threshold if first file all source
c ---                Otherwise, the first source concentration is compared to threshold
c --- Can not be applied anymore.  One of the file need to be all concentration.  tlrank(irrrk)
c --- is the file to compare to the thresh_lim
c          if(iall.eq.1) then
c          totalcomp=tlrank(irrrk)
c          else
c          totalcomp=crank(1,irrrk)
c          endif
c          if (totalcomp.ge.thresh_lim) then
c
         if(tlrank(irrrk).ge.thresh_lim) then
c
          if(ict_rec.ne.ict_rec2) then
c --- (CEC - 080201) - change output time from "end time" to "period start"
c          Write(iolst,1018)' FOR RANK    ','COORDINATES X,Y (km)    ',
c     &     '(YEAR,DAY,END TIME) ','TOTAL  ','AMBIENT_BCKG  ',
c     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES '
          Write(iolst,1018)' FOR RANK    ','COORDINATES X,Y (km)    ',
     &     '(PERIOD STARTING ON) ','TOTAL  ','AMBIENT_BCKG  ',
     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES '
c --- frr (101112 - allow more source groups on one line)
c 1018     format(a13,a24,a20,a12,51(a13))
c 1018     format(a13,a24,a20,a12,121(a13))
c --- iwl (110124 - increase number of characters in output)
 1018     format(a13,a24,a20,a12,121(a14))
          endif
          ict_rec2=ict_rec
          icount=icount+1
c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c
	istarty=namyr1(irrrk)
        istartjd=juliandy(irrrk)
        istarth=hour11(irrrk)
      call INCR(iolst,istarty,istartjd,istarth,-nhour,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
c
c ---    Write out time in format (YYYY,DDD,HH00)
c         write(atime0,'(i4.4)') namyr1(irrrk)
c         write(atime1,'(i3.3)') juliandy(irrrk)
c         write(atime2,'(i2.2)') hour11(irrrk)
          write(atime0,'(i4.4)') istarty
          write(atime1,'(i3.3)') istartjd
          write(atime2,'(i2.2)') istarth
         astime=ablnktime
         astime(2:5)=atime0(1:4)
         astime(7:9)=atime1(1:3)
         astime(11:12)=atime2(1:2)

         write(iolst,202)irrrk,xrank(irrrk),yrank(irrrk),
     &      astime,tlrank(irrrk),backgrnc,crank(1,irrrk),
     &      (crank(ii,irrrk),ii=2,NIPT),othrank(irrrk)

c --- frr (101112 - allow more source groups on one line)
c202   format(4x,i4,4x,f10.3,f10.3,7x,a15,2x,f10.3,50(4x,f9.3),
c202   format(4x,i4,4x,f10.3,f10.3,7x,a15,2x,f10.3,120(4x,f9.3),
c     &       f13.3)
c --- iwl (110124 - increase number of characters in output)
202   format(4x,i4,4x,f10.3,f10.3,7x,a15,2x,f10.3,120(4x,f10.3),
     &       f13.3)
c
c --- (CEC - 080502) - Find the number of violations
	if (crank(isrcgp,irrrk).ge.thresh_lim2) then
        iviola=iviola+1
        iviok(iviola)=irrrk
        xviok(iviola)=xrank(irrrk)
        yviok(iviola)=yrank(irrrk)
        aviotime(iviola)=astime
        tlviok(iviola)=tlrank(irrrk)
            do ii=1,NIPT
            cviok(ii,iviola)=crank(ii,irrrk)
            enddo
        othviok(iviola)=othrank(irrrk)
        endif
c
c --- Find the highest overall of each sources
          do jj=1,NIPT
          if(crank(jj,irrrk).ge.xmaxval(jj)) then
          xmaxval(jj)=crank(jj,irrrk)
          imaxyr(jj)=namyr1(irrrk)
          imaxjul(jj)=juliandy(irrrk)
          imaxhr(jj)=hour11(irrrk)
          fl_max(jj)=fl
          xrankmax(jj)=xrank(irrrk)
          yrankmax(jj)=yrank(irrrk)
          indrank(jj)=irrrk
            do ii=1,nipt
            crankmax(ii,jj)=crank(ii,irrrk)
            enddo
          tlrankmax(jj)=tlrank(irrrk)
          othrankmax(jj)=othrank(irrrk)
          endif
          enddo
c --- same for the total (file nipt1)
          if(tlrank(irrrk).ge.xmaxval(nipt1)) then
          xmaxval(nipt1)=tlrank(irrrk)
          imaxyr(nipt1)=namyr1(irrrk)
          imaxjul(nipt1)=juliandy(irrrk)
          imaxhr(nipt1)=hour11(irrrk)
          fl_max(nipt1)=fl
          xrankmax(nipt1)=xrank(irrrk)
          yrankmax(nipt1)=yrank(irrrk)
          indrank(nipt1)=irrrk
            do ii=1,nipt
            crankmax(ii,nipt1)=crank(ii,irrrk)
            enddo
          tlrankmax(nipt1)=tlrank(irrrk)
          othrankmax(nipt1)=othrank(irrrk)
          endif
c --- same for the other sources (othrank array) - (file nipt2)
          if(othrank(irrrk).ge.xmaxval(nipt2)) then
          xmaxval(nipt2)=othrank(irrrk)
          imaxyr(nipt2)=namyr1(irrrk)
          imaxjul(nipt2)=juliandy(irrrk)
          imaxhr(nipt2)=hour11(irrrk)
          fl_max(nipt2)=fl
          xrankmax(nipt2)=xrank(irrrk)
          yrankmax(nipt2)=yrank(irrrk)
          indrank(nipt2)=irrrk
            do ii=1,nipt
            crankmax(ii,nipt2)=crank(ii,irrrk)
            enddo
          tlrankmax(nipt2)=tlrank(irrrk)
          othrankmax(nipt2)=othrank(irrrk)
          endif
          endif
        Enddo
c
c --- End of processing averaging time up to half of the total number of hours
c ---
c --- For runlength averaging time 
      elseif(nhalf.lt.2) then
c
c --- Header for the output file ranked by Julian Day.
      if(iouttime.eq.1) then
      Write(ioo1,*)'Analysis of CALPUFF modeling results'
      Write(ioo1,218)'For the period: day',namdy0,'/',namyr0,'to day',
     & namdy(cntper),'/',namyr(cntper)
      WRITE(ioo1,217)'At receptor : ',xb,yb
      Write(ioo1,*)'Name of Pollutant:',asplvanl
      Write(ioo1,111)'The key group is:',asrcname(1)
      Write(ioo1,*)'Unit of concentration:',aunit
      Write(ioo1,*)'Averaging time (hour):',nhour
      Write(ioo1,215)asrcname(1),'X        ','Y        ',
     &   (asrcname(ii),ii=2,NIPT),'Background   ','Total        '
        Do iip = 1, cntper
          Write(ioo1,216)cmax(1,iip),xmax(iip),ymax(iip),
     &    (cmax(ii,iip),ii=2,NIPT),backgrnc,total(iip)
        Enddo
      endif 
c
c ----------------------------------------------------
c --- count the number of receptors with exceedances
c ---------------------------------------------------
         if(total(1).ge.thresh_lim) then
         ict_excd=ict_excd+1
         endif
c -------------------------------------
c --- Write results to output list file
c -------------------------------------
      if (ict_excd.eq.1.and.icount.eq.0) then
c
      write(iolst,*)
      write(iolst,*)'RESULTS:'
      write(iolst,*)'--------'
      write(iolst,*)

c --- Write out ranked results greater than Threshold 1
c --- Write threshold limit 1 into string
      achar8=ablnk8
      write(achar8,'(f8.2)') thresh_lim

c        write(iolst,*)'   RESULTS WHERE TOTAL EXCEEDS [',
c     &    TRIM(ADJUSTL(achar8)),' ',aunit,'] ',
c     &    'RANKED ACCORDING TO SOURCE GROUP [',
c     &    TRIM(ADJUSTL(asrcname(1))),']'
c        write(iolst,*)'   -------------------------------------------',
c     &  '---------------------------------------------------',
c     &  '------------------------------------------'

c --- frr/iwl (101112) - write(,*) format splits line in unix
      write(iolst,1007)TRIM(ADJUSTL(achar8)),aunit,
     &                 TRIM(ADJUSTL(asrcname(1)))
      write(iolst,1008)

1007  format(' RESULTS WHERE TOTAL EXCEEDS [',a8,' ',a7,'] ',
     *  'RANKED ACCORDING TO SOURCE GROUP [',a13,']')
1008  format(' ',3('---------------------------------------------'))

c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c          Write(iolst,1018)' FOR RANK    ','COORDINATES X,Y (km)    ',
c     &     '(YEAR,DAY,END TIME) ','TOTAL  ','AMBIENT_BCKG  ',
c     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES '
          Write(iolst,1018)' FOR RANK    ','COORDINATES X,Y (km)    ',
     &     '(PERIOD STARTING ON) ','TOTAL  ','AMBIENT_BCKG  ',
     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES '

c        Write(iolst,1028)' FOR RECEPTOR    ','COORDINATES X,Y (km)    ',
c     &     (asrcnametemp(ii),ii=2,NIPT),
c     &     asrcname(1),' AMB BCKG CONC ','  TOTAL  '
c1028     format(a17,a24,50(a14))
      endif
c      
        Do iip = 1, cntper
c --- cec-(070813) - the total (allsrc+bckg) is compared to threshold if first file = all source
c ---                Otherwise, the first source concentration is compared to threshold
c --- Can not be applied anymore.  One of the file need to be all concentration.  total(iip)
c --- is the file to compare to the thresh_lim 
c          if(iall.eq.1) then
c          totalcomp=total(iip)
c          else
c          totalcomp=cmax(1,iip)
c          endif
c         if (totalcomp.ge.thresh_lim) then
c
         if(total(iip).ge.thresh_lim) then
          icount=icount+1
c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c
	istarty=namyr(iip)
        istartjd=namdy(iip)
        istarth=ihour(iip)
      call INCR(iolst,istarty,istartjd,istarth,-nhour,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
c
c ---    Write out time in format (YYYY,DDD,HH00)
c         write(atime0,'(i4.4)') ieyr
c         write(atime1,'(i3.3)') jeday
c         write(atime2,'(i2.2)') iehr
         write(atime0,'(i4.4)') istarty
         write(atime1,'(i3.3)') istartjd
         write(atime2,'(i2.2)') istarth
         astime=ablnktime
         astime(2:5)=atime0(1:4)
         astime(7:9)=atime1(1:3)
         astime(11:12)=atime2(1:2)
c
          Write(iolst,202)iip,xmax(iip),ymax(iip),
     &      astime,total(iip),backgrnc,cmax(1,iip),
     &      (cmax(ii,iip),ii=2,NIPT),othsrc(iip)
c
c --- (CEC - 090227) - Find the number of violations when averaging time equal 
c                       or larger than half the entire period (nhalf < 2)
	if (cmax(isrcgp,iip).ge.thresh_lim2) then
        iviola=iviola+1
        iviok(iviola)=iip
        xviok(iviola)=xmax(iip)
        yviok(iviola)=ymax(iip)
        aviotime(iviola)=astime
        tlviok(iviola)=total(iip)
            do ii=1,NIPT
            cviok(ii,iviola)=cmax(ii,iip)
            enddo
        othviok(iviola)=othsrc(iip)
        endif

c --- Find the highest overall of each sources
          do jj=1,NIPT
          if(cmax(jj,iip).ge.xmaxval(jj)) then
          xmaxval(jj)=cmax(jj,iip)
          imaxyr(jj)=namyr(iip)
          imaxjul(jj)=namdy(iip)
          imaxhr(jj)=ihour(iip)
          fl_max(jj)=fl
          xrankmax(jj)=xmax(iip)
          yrankmax(jj)=ymax(iip)
          indrank(jj)=iip
            do ii=1,nipt
            crankmax(ii,jj)=cmax(ii,iip)
            enddo
          tlrankmax(jj)=total(iip)
          othrankmax(jj)=othsrc(iip)
          endif
          enddo
c
c --- same for the total
          if(total(iip).ge.xmaxval(nipt1)) then
          xmaxval(nipt1)=total(iip)
          imaxyr(nipt1)=namyr(iip)
          imaxjul(nipt1)=namdy(iip)
          imaxhr(nipt1)=ihour(iip)
          fl_max(nipt1)=fl
          xrankmax(nipt1)=xmax(iip)
          yrankmax(nipt1)=ymax(iip)
          indrank(nipt1)=iip
            do ii=1,nipt
            crankmax(ii,nipt1)=cmax(ii,iip)
            enddo
          tlrankmax(nipt1)=total(iip)
          othrankmax(nipt1)=othsrc(iip)
          endif
c
c --- same for the other sources
          if(othsrc(iip).ge.xmaxval(nipt2)) then
          xmaxval(nipt2)=othsrc(iip)
          imaxyr(nipt2)=namyr(iip)
          imaxjul(nipt2)=namdy(iip)
          imaxhr(nipt2)=ihour(iip)
          fl_max(nipt2)=fl
          xrankmax(nipt2)=xmax(iip)
          yrankmax(nipt2)=ymax(iip)
          indrank(nipt2)=iip
            do ii=1,nipt
            crankmax(ii,nipt2)=cmax(ii,iip)
            enddo
          tlrankmax(nipt2)=total(iip)
          othrankmax(nipt2)=othsrc(iip)
          endif
c
          endif
        Enddo
c
      endif 
c --- End of writing out for runlength averaging time
 111  format(a17,1x,a13)
 211  Format(a10,a7,5x,a13,2(1x,a9),50(1x,a13))
c CdA
c 212  Format(I4,1x,I3,2x,I7,1x,f13.4,2(1x,f9.3),50(1x,f13.8))
 212  Format(I4,1x,I3,2x,I7,1x,f13.4,2(1x,f9.3),50(1x,f13.4))
 213  Format(a5,a10,a7,5x,a13,4x,a10,1x,a10,2x,50(1x,a13))
c CdA
 214  Format(2(i4,1x),I3,2x,I4,4x,f13.3,4x,2(1x,f9.3),50(1x,f13.3))
 215  Format(6x,a13,2(1x,a10),2x,50(1x,a13))
c 216  Format(2x,i13,4x,2(1x,f9.3),50(1x,f13.3))
 216  Format(2x,f13.3,4x,2(1x,f9.3),50(1x,f13.3))
 217  FORMAT(a14,2(f9.3))
 218  FORMAT(a19,i4,a1,i4,a6,i4,a1,i4)
 219  Format(i4,1x,I3,2x,I4,4x,f13.3,4x,2(1x,f9.3),50(1x,f13.3))
 220  Format(a10,a7,5x,a13,4x,a10,1x,a10,2x,50(1x,a13))
c --- Close output files ioo1
      CLOSE(ioo1)
      goto 500
c --- close loop over number of receptors.
c
c --- cec(070815) - end "if" when ict_rec=0.
      else
      goto 506
      endif
c   
c --- cec-(070815) - if additional process needed: imore=1
c                    the process of reading CALPUFF files will go forward.
c                    even if no receptors are above the thres_lim.
501	   if(imore.eq.1.and.ict_rec.eq.0) goto 505
c 
506   write(iolst,*)' '
      write(iolst,*)'     TOTAL NUMBER OF EXCEEDANCES = ',icount
      write(iolst,*)
      write(iolst,*)'     NUMBER OF RECEPTORS WITH EXCEEDANCE(S) = ',
     &  ict_excd
c
      if(ict_excd.eq.0) then
c ---   Write Threshold Limit 2 into string
        achar8=ablnk8
        write(achar8,'(f8.2)') thresh_lim
      write(iolst,*)
      write(iolst,*)'RESULTS:'
      write(iolst,*)'--------'
      write(iolst,*)
      write(iolst,*)'NO RECEPTORS IN THE LIST OF RECEPTORS PROVIDED '
      write(iolst,*)'HAVE A TOTAL CONCENTRATION ABOVE THE THRESHOLD [',
     &    TRIM(ADJUSTL(achar8)),' ',aunit,']'
c
c --- Write out maximums for each source group
      elseif(ict_excd.ne.0) then
c
c ---   Write Threshold Limit 2 into string
        achar8=ablnk8
        write(achar8,'(f8.2)') thresh_lim

        asrcname(nipt1)='TOTAL         '
        asrcname(nipt2)='OTHER SOURCES '
c
      write(iolst,*)' '
      write(iolst,*)'SUMMARY:'
      write(iolst,*)'--------'
      write(iolst,*)' '
c----------------------------------------------------------------------
c      write(iolst,*)'MAXIMUM CONCENTRATION FOR SOURCE LISTED IN',
c     &   ' COLUMN 1 - CONCENTRATION FOR OTHER SOURCES ON SAME',
c     &   ' PERIOD AND RECEPTOR'
c      write(iolst,*)'WHEN TOTAL CONCENTRATION IS LARGER THAN [',
c     &    TRIM(ADJUSTL(achar8)),' ',aunit,']'
c       write(iolst,*)'------------------------------------------------',
c      &  '-------------------------------------------------------------'
      write(iolst,1005)
      write(iolst,1006)TRIM(ADJUSTL(achar8)),aunit
      write(iolst,1008) 

1005  format(' MAXIMUM CONCENTRATION FOR SOURCE LISTED IN',
     &   ' COLUMN 1 - CONCENTRATION FOR OTHER SOURCES ON SAME',
     &   ' PERIOD AND RECEPTOR')
1006  format(' WHEN TOTAL CONCENTRATION IS LARGER THAN [',
     &    a8,' ',a7,']')
c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c
c        Write(iolst,1017)'SOURCE ','RANK ',' COORDINATES X,Y(km)   ',
c     &     '(YEAR,DAY,END TIME) ','TOTAL     ','AMBIENT_BCKG  ',
c     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES'
        Write(iolst,1017)'SOURCE ','RANK ',' COORDINATES X,Y(km)   ',
     &     '(PERIOD STARTING ON) ','TOTAL     ','AMBIENT_BCKG  ',
     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES'
c
      do jj=1,nipt2
c
 1016    Format(a52)
 1017    Format(a11,a7,a23,a20,a12,2a13,a10,48(a13))

c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c
	istarty=imaxyr(jj)
        istartjd=imaxjul(jj)
        istarth=imaxhr(jj)
      call INCR(iolst,istarty,istartjd,istarth,-nhour,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
c
c ---   Write out time in format (YYYY,DDD,HH00)
c        write(atime0,'(i4.4)') imaxyr(jj)
c        write(atime1,'(i3.3)') imaxjul(jj)
c        write(atime2,'(i2.2)') imaxhr(jj)
        write(atime0,'(i4.4)') istarty
        write(atime1,'(i3.3)') istartjd
        write(atime2,'(i2.2)') istarth
        astime=ablnktime
        astime(2:5)=atime0(1:4)
        astime(7:9)=atime1(1:3)
        astime(11:12)=atime2(1:2)

c        write(iolst,203)xrankmax(jj),yrankmax(jj),
c     &      astime,(crankmax(ii,jj),ii=2,NIPT),
c     &      crankmax(1,jj),backgrnc,tlrankmax(jj)
c --- (CEC - 071214)
         write(iolst,203)TRIM(ADJUSTL(asrcname(jj))),indrank(jj),
     &      xrankmax(jj),yrankmax(jj),
     &      astime,tlrankmax(jj),backgrnc,crankmax(1,jj),
     &     (crankmax(ii,jj),ii=2,NIPT),othrankmax(jj)
      enddo

203   format(a13,1x,i3,1x,f10.3,f10.3,4x,a15,1x,f10.3,50(4x,f9.3),
     &       1x,f13.3)
      endif
c
c -------------------------------------------------------------------------------------------
c --- Write number of violations if any
c
c ---   Write Threshold Limit and Threshold Limit2 into string
        achar8=ablnk8
        write(achar8,'(f8.2)') thresh_lim
        achar8b=ablnk8
        write(achar8b,'(f8.2)') thresh_lim2

      write(iolst,*)' '
      write(iolst,*)' '
      write(iolst,*)'TOTAL NUMBER OF POTENTIAL VIOLATIONS = ',iviola,
     & ' (Exclude Rank 1 values if standard is based',
     & ' on second exceedance)'
      write(iolst,*)'------------------------------------------'
      write(iolst,*)' '
c
      if(iviola.ne.0) then
c      write(iolst,*)'FOR THE FOLLOWING RECEPTORS AND PERIODS',
c     & ' TOTAL IS LARGER THAN [',
c     &   TRIM(ADJUSTL(achar8)),' ',aunit,'] and ',
c     &   TRIM(ADJUSTL(asrcnametemp(isrcgp))),' IS LARGER THAN [',
c     &   TRIM(ADJUSTL(achar8b)),' ',aunit,']'
c       write(iolst,*)'------------------------------------------------',
c      &  '-------------------------------------------------------------'
      write(iolst,1004)TRIM(ADJUSTL(achar8)),aunit,
     &   TRIM(ADJUSTL(asrcnametemp(isrcgp))),
     &   TRIM(ADJUSTL(achar8b)),aunit
      write(iolst,1008) 

1004  format(' FOR THE FOLLOWING RECEPTORS AND PERIODS',
     & ' TOTAL IS LARGER THAN [',
     &   a8,' ',a7,'] and ',
     &   a13,' IS LARGER THAN [',
     &   a8,' ',a7,']')

      Write(iolst,1018)' FOR RANK    ','COORDINATES X,Y (km)    ',
     &     '(PERIOD STARTING ON) ','TOTAL  ','AMBIENT_BCKG  ',
     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES '
c
         do iv=1,iviola
         if(iviok(iv).eq.1) then
         write(iolst,202)iviok(iv),xviok(iv),yviok(iv),
     &      aviotime(iv),tlviok(iv),backgrnc,cviok(1,iv),
     &      (cviok(ii,iv),ii=2,NIPT),othviok(iv)
         endif
         enddo
      write(iolst,*)' '
         do iv=1,iviola
         if(iviok(iv).ne.1) then
         write(iolst,202)iviok(iv),xviok(iv),yviok(iv),
     &      aviotime(iv),tlviok(iv),backgrnc,cviok(1,iv),
     &      (cviok(ii,iv),ii=2,NIPT),othviok(iv)
         endif
         enddo
       else
       write(iolst,*)'NO VIOLATIONS '
       endif
c
c --------------------------------------------------------------------------------------------
c --- Write more analysis if required - More analysis = 1
c --- Find the highest total concentration (none Rank 1) when selected group source (isrcgp) 
c --- is larger than 2nd threshold
c
c --- Initialize irk - will count the number of receptor with a Rank 1
          irk=0
c
          if(imore.eq.1) then
c
        write(iolst,*)
        write(iolst,*)
        write(iolst,*)
        write(iolst,*)'ADDITIONAL RESULTS'
        write(iolst,*)'------------------'
c
c - Define iall if ict_rec=0
      if (ict_rec.eq.0) then
      iall = 0
      do ifile = 1,nipt
        if(asrcname(ifile)(1:3).eq.'ALL'.or.
     &     asrcname(ifile)(1:3).eq.'All'.or.
     &     asrcname(ifile)(1:3).eq.'all') THEN
          iall = ifile
        endif
      enddo
      endif
c
      if(iall.eq.0) then
c --- None of the file listed includes all the sources modeled
c
       write(iolst,*)' ' 
       write(iolst,*)'ERROR - ONE OF THE FILE NEEDS TO INCLUDE'
c----------------------------------------------------------------------
       write(iolst,*)'ALL THE SOURCES MODELED - AND FIRST THREE',
     &               ' LETTERS'
       write(iolst,*)'OF THE SOURCE NAME NEED TO BE "ALL".' 
       halt132(1:48)='ERROR - ONE OF THE FILE NEEDS TO INCLUDE ALL SRC'
       do i=49,132
         halt132(i:i)=' '
       enddo
       goto 1001
      endif
c
c --- Do not do this analysis if averaging period is larger or equal to half the total number of hours
          if(nhalf.lt.2.and. lrank) then
            write(iolst,*)' '
            write(iolst,*)'THE NB OF HOURS IN AVERAGING PERIOD IS',
     &                    ' LARGER'
            write(iolst,*)' THAN HALF OF TOTAL HOURS - ' 
            write(iolst,*)'RANK 2 CAN NOT BE COMPUTED'
            halt132(1:43)='THE NB OF HRS IN AVERAGING PERIOD IS LARGER'
            halt132(44:69)=' THAN HALF OF TOTAL HRS - ' 
            halt132(70:95)='RANK 2 CAN NOT BE COMPUTED'
            do i=96,132
               halt132(i:i)=' '
            enddo
            goto 1001
          endif
c
          Do iip=1,cntper
c
c --- 1 - for gridded receptors if any
          if(LSGRID)then
            do i=1,ngx
             do j=1,ngy
         jrec1=(isrcgp-1)*cntper*ngx*ngy+(iip-1)*ngy*ngx+ngy*(i-1)+j
             read(iox1,100,rec=jrec1)avPERcg2
c             avPERcg2=avPERcg(i,j)
               if(avPERcg2.ge.thresh_lim2) then
               allconc=0.
               others=0.
               do k=1,nipt
          jrec1=(k-1)*cntper*ngx*ngy+(iip-1)*ngy*ngx+ngy*(i-1)+j
               read(iox1,100,rec=jrec1)crankmax1(k)
c --- cec (071217) - Since not all the sources need to be listed as files - 
c                    the file containing all the concentrations need to be listed 
c                    and is used to get the allconc value
c                  if(k.ne.iall) then
c                  allconc=allconc+crankmax1(k)               
c                  endif
                  if(k.eq.iall) then
                  allconc=crankmax1(k)
                  others=others+crankmax1(k)
                  else
                  others=others-crankmax1(k)
                  endif
               enddo
               if(backgrnc.gt.0.0) then
               allconc = allconc + backgrnc
               endif
c
c --- cec-(070813) - check that the allconc is not one of the Rank1 above the first threshold
c ---                and only 1 rank by receptor is removed
               if(lrank) then
               do ll=1,ir-1
               xdif1=abs(allconc-xval1(ll))
               xdif2=abs(xgrd(i,j)-xb1(ll))
               xdif3=abs(ygrd(i,j)-yb1(ll))
               if(xdif1.le.0.001.and.xdif2.le.0.001.and.
     &         xdif3.le.0.001) then
                if(irk.ge.1) then
                do ll1=1,irk
                 if(irk_1(ll1).eq.ll) then
                 write(iolst,*)' '
                 write(iolst,*)'RANK 1 EQUAL TO RANK 2 FOR RECEPTOR: '
     &             ,xgrd(i,j),ygrd(i,j)
                 write(iolst,*)' CONCENTRATION = ',allconc
                 goto 133
                 endif
                enddo
                endif
               irk=irk+1
               irk_1(irk)=ll              
               goto 130
               endif
               enddo
               endif
c
133           if(allconc.ge.xmaxval2) then
              xmaxval2=allconc
              imaxyr2=namyr(iip)
              imaxjul2=namdy(iip)
              imaxhr2=ihour(iip)
              fl_max2='gridded'
              xrankmax2=xgrd(i,j)
              yrankmax2=ygrd(i,j)
                  do k=1,nipt
                  crankmax2(k)=crankmax1(k)
                  enddo
              tlrankmax2=allconc
              othrankmax2=others
              ireceptID=i
              endif
              endif  
130          enddo
            enddo
           endif
c
c --- 2 - for discret receptors if any
           if(ndrec.gt.0)then
              do i=1,ndrec
              jrec2=(isrcgp-1)*cntper*ndrec+(iip-1)*ndrec+i
              read(iox2,100,rec=jrec2)avPERcd2
c              avPERcd2=avPERcd(i)
              if(avPERcd2.ge.thresh_lim2) then
              allconc=0.
              others=0.
                 do k=1,nipt
                 jrec2=(k-1)*cntper*ndrec+(iip-1)*ndrec+i
                 read(iox2,100,rec=jrec2)crankmax1(k)
c --- cec (071217) - Since not all the sources need to be listed as files - 
c                    the file containing all the concentrations need to be listed 
c                    and is used to get the allconc value
c                  if(k.ne.iall) then
c                  allconc=allconc+crankmax1(k)               
c                  endif
                   if(k.eq.iall) then
                   allconc=crankmax1(k)
                   others=others+crankmax1(k)
                   else
                   others=others-crankmax1(k)
                   endif
                 enddo
                 if(backgrnc.gt.0.0) then
                 allconc = allconc + backgrnc
                 endif
c
c --- cec-(070813) - check that the allconc is not one of the Rank1 above the first threshold
c ---                and only 1 rank by receptor is removed
               if(lrank) then
               do ll=1,ir-1
               xdif1=abs(allconc-xval1(ll))
               xdif2=abs(xrec(i)-xb1(ll))
               xdif3=abs(yrec(i)-yb1(ll))
               if(xdif1.le.0.001.and.xdif2.le.0.001.and.
     &         xdif3.le.0.001) then
                if(irk.ge.1) then
                 do ll1=1,irk
                  if(irk_1(ll1).eq.ll) then
                  write(iolst,*)' '
                  write(iolst,*)'RANK 1 EQUAL TO RANK 2 FOR RECEPTOR: '
     &             ,xrec(i),yrec(i)
                  write(iolst,*)' CONCENTRATION = ',allconc
                  goto 134
                  endif
                 enddo
                endif
               irk=irk+1
               irk_1(irk)=ll              
               goto 131
               endif
               enddo
             endif
c
134            if(allconc.ge.xmaxval2) then
               xmaxval2=allconc
               imaxyr2=namyr(iip)
               imaxjul2=namdy(iip)
               imaxhr2=ihour(iip)
               fl_max2='discret'
               xrankmax2=xrec(i)
               yrankmax2=yrec(i)
                 do k=1,nipt
                 crankmax2(k)=crankmax1(k)
                 enddo
               tlrankmax2=allconc
               othrankmax2=others
               ireceptID=i
               endif
              endif  
131           enddo
           endif
c
c --- 3 - for complex receptors if any
c              if(nctrec.gt.0)then
           if(LCTSG)then
              do i=1,nctrec
              jrec3=(isrcgp-1)*cntper*nctrec+(iip-1)*nctrec+i
              read(iox3,100,rec=jrec3)avPERct2
c              avPERct2=avPERct(i)
                if(avPERct2.ge.thresh_lim2) then
                allconc=0.
                others=0.
                 do k=1,nipt
                 jrec3=(k-1)*cntper*nctrec+(iip-1)*nctrec+i
                 read(iox3,100,rec=jrec3)crankmax1(k)
c --- cec (071217) - Since not all the sources need to be listed as files - 
c                    the file containing all the concentrations need to be listed 
c                    and is used to get the allconc value
c                  if(k.ne.iall) then
c                  allconc=allconc+crankmax1(k)               
c                  endif
                  if(k.eq.iall) then
                  allconc=crankmax1(k)
                  others=others+crankmax1(k)
                  else
                  others=others-crankmax1(k)
                  endif
                 enddo
                 if(backgrnc.gt.0.0) then
                 allconc = allconc + backgrnc
                 endif
c
c --- cec-(070813) - check that the allconc is not one of the Rank1 above the first threshold
                 if(lrank) then
                 do ll=1,ir-1
                 xdif1=abs(allconc-xval1(ll))
                 xdif2=abs(xctr(i)-xb1(ll))
                 xdif3=abs(yctr(i)-yb1(ll))
                 if(xdif1.le.0.001.and.xdif2.le.0.001.and.
     &           xdif3.le.0.001) then 
                 if(irk.ge.1) then
                 do ll1=1,irk
                  if(irk_1(ll1).eq.ll) then
                  write(iolst,*)' '
                  write(iolst,*)'RANK 1 EQUAL TO RANK 2 FOR RECEPTOR: '
     &             ,xctr(i),yctr(i)
                  write(iolst,*)' CONCENTRATION = ',allconc
                  goto 135
                  endif
                 enddo
                 endif
                 irk=irk+1
                 irk_1(irk)=ll              
                 goto 132
                 endif
                 enddo
                 endif
c
135              if(allconc.ge.xmaxval2) then
                 xmaxval2=allconc
                 imaxyr2=namyr(iip)
                 imaxjul2=namdy(iip)
                 imaxhr2=ihour(iip)
                 fl_max2='complex'
                 xrankmax2=xctr(i)
                 yrankmax2=yctr(i)
                  do k=1,nipt
                  crankmax2(k)=crankmax1(k)
                  enddo
                 tlrankmax2=allconc
                 othrankmax2=others
                 ireceptID=i
                 endif
                endif  
132            enddo
           endif
        Enddo
c
c ---   Write Threshold Limit 2 into string
        achar8=ablnk8
        write(achar8,'(f8.2)') thresh_lim2
c
        write(iolst,*)
        if(lrank) then
c        write(iolst,*)'   RESULTS FOR MAXIMUM TOTAL CONCENTRATION ',
c     &    '(EXCLUDING RANK 1 VALUES) WHEN SOURCE GROUP [',
c     &    TRIM(ADJUSTL(asrcname(isrcgp))),'] EXCEEDS [',
c     &    TRIM(ADJUSTL(achar8)),' ',aunit,']'
        write(iolst,1002)TRIM(ADJUSTL(asrcname(isrcgp))),
     &    TRIM(ADJUSTL(achar8)),aunit
        else
c        write(iolst,*)'   RESULTS FOR MAXIMUM TOTAL CONCENTRATION ',
c     &    '(RANK 1 VALUE INCLUDED) WHEN SOURCE GROUP',
c     &    ' [',TRIM(ADJUSTL(asrcname(isrcgp))),'] EXCEEDS [',
c     &    TRIM(ADJUSTL(achar8)),' ',aunit,']'
        write(iolst,1003)TRIM(ADJUSTL(asrcname(isrcgp))),
     &    TRIM(ADJUSTL(achar8)),aunit
        endif
c         write(iolst,*)'   ------------------------------------------',
c      &  '-----------------------------------------------------------',
c      &  '-----------------------'
      write(iolst,1008) 

1002  format(' RESULTS FOR MAXIMUM TOTAL CONCENTRATION ',
     &    '(EXCLUDING RANK 1 VALUES) WHEN SOURCE GROUP [',
     &    a13,'] EXCEEDS [',
     &    a8,' ',a7,']')
1003  format(' RESULTS FOR MAXIMUM TOTAL CONCENTRATION ',
     &    '(RANK 1 VALUE INCLUDED) WHEN SOURCE GROUP',
     &    ' [',a13,'] EXCEEDS [',
     &    a8,' ',a7,']')
c
        if(crankmax2(isrcgp).ge.thresh_lim2) then
c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c
c         Write(iolst,1013)'RECPTID ',' COORDINATES X,Y(km)   ',
c     &     '(YEAR,DAY,END TIME) ','TOTAL     ','AMBIENT_BCKG  ',
c     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES'
         Write(iolst,1013)'RECPTID ',' COORDINATES X,Y(km)   ',
     &     '(PERIOD STARTING ON) ','TOTAL     ','AMBIENT_BCKG  ',
     &     asrcname(1),(asrcnametemp(ii),ii=2,NIPT),'OTHER_SOURCES'
c 1011    Format(a43,a45,a15,a11,a8,a1,a7,a1)
c 1012    Format(a46,a59,a23)
 1013    Format(a7,a23,a20,a12,2a13,a12,48(a13))
c
c
c --- (CEC - 080201) - change output time from "end time" to "period start"
c
	istarty=imaxyr2
        istartjd=imaxjul2
        istarth=imaxhr2
      call INCR(iolst,istarty,istartjd,istarth,-nhour,halt132)
      if(halt132(1:6) .NE. 'NORMAL') goto 1001
c
c ---     Write out time in format (YYYY,DDD,HH00)
c          write(atime0,'(i4.4)') imaxyr2
c          write(atime1,'(i3.3)') imaxjul2
c          write(atime2,'(i2.2)') imaxhr2
          write(atime0,'(i4.4)') istarty
          write(atime1,'(i3.3)') istartjd
          write(atime2,'(i2.2)') istarth
          astime=ablnktime
          astime(2:5)=atime0(1:4)
          astime(7:9)=atime1(1:3)
          astime(11:12)=atime2(1:2)

          write(iolst,204)ireceptID,xrankmax2,yrankmax2,
     &      astime,tlrankmax2,backgrnc,crankmax2(1),
     &     (crankmax2(ii),ii=2,NIPT),othrankmax2
c
204   format(2x,i4,1x,f10.3,f10.3,6x,a15,1x,f10.3,50(4x,f9.3),
     &       1x,f13.3)
c
        else
          write(iolst,*)'THE CONCENTRATIONS OF [',
     &      TRIM(ADJUSTL(asrcname(isrcgp))),'] NEVER EXCEED [',
     &      TRIM(ADJUSTL(achar8)),' ',aunit,']'
c 1014    Format(a23,a15,a16,a8,a1,a7,a1)
        endif
          if(lrank) then
          write(iolst,*)
          write(iolst,*)'NUMBER OF RANK 1 REMOVED = ',irk
          endif
      endif
c
c --- TERMINATION PHASE -- program termination functions
      call FIN
1001  continue
      write(iomsg,*) halt132

c --- Write completed run status message to end of list file
      if(halt132(1:6) .NE. 'NORMAL') then
        write(iolst,*)
        write(iolst,*)halt132
        write(iolst,*)
        write(iolst,*)'----------'
        write(iolst,*)'RUN FAILED'
      else
        write(iolst,*)
        write(iolst,*)'-------------'
        write(iolst,*)'RUN COMPLETED'
      endif

c --- Close any files that remain open
      close(in2)
      close(in4)
      close(iolst)
      close(iox1)
      close(iox2)
      close(iox3)
c
      stop
      end
c-----------------------------------------------------------------------
      block data
c-----------------------------------------------------------------------
c
c --- CALPOST   Version: 6.38         Level: 980515            BLOCK DATA
c ---           D. Strimaitis, J. Scire, SRC
c
c     PURPOSE:     Provides initial values or default values to members
c                  of common blocks used in CALPOST code.
c
c
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'head.ans'
      INCLUDE 'filnam.ans'
c
c  Section for members of common /ctrl/:
      data LSCALE/.TRUE./,iecho/366*0/
      data LBACK/.FALSE./
      data a/0./,b/0./
      data ilayer/1/, iprtu/1/
c      data L1EXC/.FALSE./,L3EXC/.FALSE./,L24EXC/.FALSE./,LNEXC/.FALSE./
      data thresh1/-1.0/,thresh3/-1.0/,thresh24/-1.0/,threshN/-1.0/
      data LDEBUG/.FALSE./
      data LG/.false./,LD/.false./,LCT/.FALSE./
c      data L1T50/.false./,L3T50/.false./,L24T50/.false./,LNT50/.false./,
c     &     LRT50/.false./
      data navg/0/,ntop/4/,itop/1,2,3,4/
c      data L1TOPN/.false./,L3TOPN/.false./,L24TOPN/.false./,
c     &     LNTOPN/.false./,LRAVG/.false./
c      data LECH1/.false./,LECH3/.false./,LECH24/.false./,LECHN/.false./
c      data LPLT/.false./
c      data LTGRD/.false./,LXGRD/.false./,LEGRD/.false./
c      data NREP/1/
c
c --- FILNAM, FILLOG common blocks
      data pstinp/'calanalysis.inp'/,pstlst/'calanalysis.lst'/,
     1 moddat/'model.dat'/,visdat/'visb.dat'/,
     2 backdat/'back.dat'/
      data npath/0/
      data lcfiles/.true./
c
      end

c-----------------------------------------------------------------------
      subroutine gethead(io,halt132)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40         Level: 110301         GETHEAD
c --- CALPOST   Version: 5.6393         Level: 060202           GETHEAD
c ---           D. Strimaitis
c
c  PURPOSE:     Reads header information from concentration file
c               and passes information to main program through
c               common /HEAD/.  Source names are passed into /SOURCE/.
c
c  CALANALYSIS UPDATES:
c     V6.27(071001) to V6.38(110301)
c         - Add Dataset v2.2 (use only if data are in mass units)
c     V5.6393(060202) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c  NOTE: CALPOST subroutine EXCEPT extension filenames (.ans  intead of .pst)
c
c  UPDATES:
c     V5.637(050321) to V5.6393(060202)
c               (CEC) check size of CALMET domain (ielmet, jelmet)against
c                     maximum limits for gridded receptors put in PARAMS.PST
c     V5.63(040623) to V5.637(050321)
c               (DGS) Fix typo in reading line source type 2 names into
c                     array -- 
c                     n2=21+nln2 should be n2=n2+nln2
c                     (CALPUFF dataset version 2.1)
c     V5.61(040123) to V5.63(040623)
c               (DGS) Fix bug in reading source names into array
c                     (CALPUFF dataset version 2.1)
c     V5.6(031017) to V5.61(040123)
c               (DGS) Fix bug that caused error in reading 'old'
c                     files (iptime replaces irhtime)
c     V5.5(030627) to V5.6(031017)
c               (DGS) Add dataset version 2.1 format
c     V5.4(030402) to V5.5(030627)
c               (DGS) Add structure for  dataset version > 2.0
c     V5.1(990709) to V5.4(030402)
c               (DGS) add list-file unit to INCR, YR4
c               (FRR) i2drh flag in all header records
c               (DGS) Dataset version 2.0 format
c     V5.0(980918) to V5.1(990709)
c               (DGS) begin-time end-time format resolved to seconds
c                     and enforce YYYY year format
c     V5.0(980515) to V5.0(980918)
c               (DGS) NSDUM replaces NSSTA
c     V5.0(960422) to V5.0(980515)
c               (DGS) Expand error reports
c
c  ARGUMENTS:
c     PASSED:   io      Unit number for accessing input file         [i]
c          HALT132 - character*132     - Status string
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   INCR, YR4, GETDOC
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'head.ans'
      INCLUDE 'source.ans'
c -- Note: all declaration statements for data read in by GETHEAD
c          are contained in the included commons

      character*132 halt132

      character*48 msg(8),msg0
      logical lfatal, lfatal2
      logical lspunit

      data msg0  /'  **********************************************'/
      data msg(1)/'  *      FATAL Problem Found in GETHEAD!       *'/
      data msg(2)/'  * ------------------------------------------ *'/
      data msg(3)/'  *  Size of Array(s) in MODEL.DAT too Large   *'/
      data msg(4)/'  *  Re-size Array Parameter(s) in PARAMS.PST  *'/
      data msg(5)/'  *         and Recompile CALPOST              *'/
      data msg(6)/'  * ------------------------------------------ *'/
      data msg(7)/'  * Parameter       PARAMS.PST       MODEL.DAT *'/
      data msg(8)/'  * ---------       ----------       --------- *'/

      lfatal=.FALSE.
      lfatal2=.FALSE.
      lspunit=.FALSE.

c --- Process first section of CALPUFF output file (including comment
c --- records), and determine dataset version
      call GETDOC(io,idtype,cpver)
c
c  Read control variables (record NCOM+3)
      if(idtype.EQ.0) then
         i2drh=0
         read(io) amodel,aver,alev,msyr,mjsday,mshr,mnhrs,mavg,
     *         ielmet,jelmet,delx,dely,nz,xorigkm,yorigkm,nsdum,
     *         iastar,iastop,jastar,jastop,
     *         isastr,jsastr,isastp,jsastp,
     *         meshdn,npts,nareas,nlines,nvols,
     *         ndrec,nctrec,LSGRID,nszout,lcomprs
         iptime=1
         isrcinfo=0
         isrcindv=0
         nsrc=0
      else
c ---    Dataset version 2.0 and later format
         if(cpver.EQ.'2.0             ') then
           read(io) amodel,aver,alev,msyr,mjsday,mshr,mnhrs,mavg,
     *         ielmet,jelmet,delx,dely,nz,xorigkm,yorigkm,nsdum,
     *         iastar,iastop,jastar,jastop,
     *         isastr,jsastr,isastp,jsastp,
     *         meshdn,npts,nareas,nlines,nvols,
     *         ndrec,nctrec,LSGRID,nszout,lcomprs,i2drh,
     *         iutmzn,feast,fnorth,rnlat0,relon0,xlat1,xlat2,
     *         pmap,utmhem,datum,daten,clat0,clon0,clat1,clat2
           iptime=1
           isrcinfo=0
           isrcindv=0
           nsrc=0

         elseif(cpver.EQ.'2.1             ') then
           read(io) amodel,aver,alev,msyr,mjsday,mshr,mssec,xbtz,
     *         mnrun,mavgpd,nsecdt,
     *         ielmet,jelmet,delx,dely,nz,xorigkm,yorigkm,nsdum,
     *         iastar,iastop,jastar,jastop,
     *         isastr,jsastr,isastp,jsastp,
     *         meshdn,npt1,npt2,nar1,nar2,nln1,nln2,nvl1,nvl2,msource,
     *         ndrec,nctrec,LSGRID,nszout,lcomprs,i2drh,
     *         iutmzn,feast,fnorth,rnlat0,relon0,xlat1,xlat2,
     *         pmap,utmhem,datum,daten,clat0,clon0,clat1,clat2
           iptime=2
           isrcinfo=1
           isrcindv=msource
           npts=npt1+npt2
           nareas=nar1+nar2
           nlines=nln1+nln2
           nvols=nvl1+nvl2
           nsrc=npts+nareas+nlines+nvols

         elseif(cpver.EQ.'2.2             ') then
           read(io) amodel,aver,alev,msyr,mjsday,mshr,mssec,abtz,
     *         mnrun,mavgpd,nsecdt,
     *         ielmet,jelmet,delx,dely,nz,xorigkm,yorigkm,nsdum,
     *         iastar,iastop,jastar,jastop,
     *         isastr,jsastr,isastp,jsastp,
     *         meshdn,npt1,npt2,nar1,nar2,nln1,nln2,nvl1,nvl2,msource,
     *         ndrec,nctrec,LSGRID,nszout,lcomprs,i2drh,
     *         iutmzn,feast,fnorth,rnlat0,relon0,xlat1,xlat2,
     *         pmap,utmhem,datum,daten,clat0,clon0,clat1,clat2
           iptime=2
           isrcinfo=1
           isrcindv=msource
           npts=npt1+npt2
           nareas=nar1+nar2
           nlines=nln1+nln2
           nvols=nvl1+nvl2
           nsrc=npts+nareas+nlines+nvols
c ---      Convert from UTC string to real base time zone
           call UTCBASR(abtz,xbtz)
c ---      Specie-level units are in header
           lspunit=.TRUE.

         else
           write(iolst,*)'ERROR:  Unknown DATASET Version: ',cpver
           halt132(1:36)='Halted in GETHEAD  --  See list file'
           do i=37,132
              halt132(i:i)=' '
           enddo
           return
         endif
      endif

c	   write(6,*)'cpver:',cpver
c	   write(6,*)'number of sources:',nsrc


c --- Check year format
      call YR4(iolst,msyr,ierry)
      if(ierry.NE.0) then
         halt132(1:36)='Halted in GETHEAD  --  See list file'
         do i=37,132
            halt132(i:i)=' '
         enddo
         return
      endif

      if(iptime.EQ.1) then
c ---    Move starting time back 1 hour to identify the start of the
c ---    first hour
         call INCR(iolst,msyr,mjsday,mshr,-1,halt132)
         if(halt132(1:6) .NE. 'NORMAL') return
c ---    Set period step to 1 hour
         nsecdt=3600
         mssec=0
c ---    Rename averaging period variables
         mnrun=mnhrs
         mavgpd=mavg
      endif

c  Use nsdum to satisfy compiler checks
      if(nsdum .EQ. nssta) nsdum=nssta
c
c  Check size of array dimensions (compute gridded rec. array dims.)
c  with limits contained in PARAMS.PST file
      ngx=(isastp-isastr)*meshdn+1
      ngy=(jsastp-jsastr)*meshdn+1
      ngrec=ngx*ngy
      if(ngx .GT. mxgx) lfatal=.TRUE.
      if(ngy .GT. mxgy) lfatal=.TRUE.
      if(ndrec .GT. mxdrec) lfatal=.TRUE.
      if(nctrec .GT. mxctrec) lfatal=.TRUE.
      if(nszout .GT. mxsplv) lfatal=.TRUE.
      if(nsrc .GT. mxsrc) lfatal=.TRUE.
c
c --- CEC (060202) - check size of CALMET domain compare to maximum
c                    limits for gridded receptors put in PARAMS.PST
      IF(ielmet.gt.mxgx) lfatal2=.TRUE.
      IF(jelmet.gt.mxgy) lfatal2=.TRUE.

      if(LFATAL) then
c ---    Report problem information and quit
c ---    Screen (io6) and List File (iolst):
c ---    Set for screen first
         halt132(1:36)='Halted in GETHEAD  --  See list file'
         do i=37,132
            halt132(i:i)=' '
         enddo
c ---    List file unit
         iu=iolst
           write(iu,*)
           write(iu,100) msg0
           do i=1,8
              write(iu,100) msg(i)
           enddo
           write(iu,101)'  *     MXGX',mxgx,ngx
           write(iu,101)'  *     MXGY',mxgy,ngy
           write(iu,101)'  *   MXDREC',mxdrec,ndrec
           write(iu,101)'  *  MXCTREC',mxctrec,nctrec
           write(iu,101)'  *   MXSPLV',mxsplv,nszout
           write(iu,101)'  *    MXSRC',mxsrc,nsrc
           write(iu,100) msg0
         return
      endif
c
      if(LFATAL2) then
c ---    Report problem information and quit
c ---    Screen (io6) and List File (iolst):
c ---    Set for screen first
         halt132(1:36)='Halted in GETHEAD  --  See list file'
         do i=37,132
            halt132(i:i)=' '
         enddo
c ---    List file unit
         iu=iolst
           write(iu,*)
           write(iu,100) msg0
           do i=1,8
              write(iu,100) msg(i)
           enddo
           write(iu,101)'  *     MXGX ',mxgx,ielmet
           write(iu,101)'  *     MXGY ',mxgy,jelmet
           WRITE(iu,*)'  *  Maximum of gridded receptor need to be    *'
           WRITE(iu,*)'  *  at least same size as CALMET grid         *'
           write(iu,100) msg0
         return
      endif
c
c  Read title of run (record NCOM+4)
      read(io) atitle
c
c  Read specie/level list (record NCOM+5)
      read(io) (asplst(i),i=1,nszout)

c --- Read units for each specie/level in list (record NCOM+5a)
c --- (introduced in Dataset 2.2)
      if(LSPUNIT) then
         read(io) (aspunit(i),i=1,nszout)
      else
         do i=1,nszout
            if(asplst(i)(15:15).EQ.'F') then
               aspunit(i)='g/m2/s          '
            else
               aspunit(i)='g/m3            '
            endif
         enddo
      endif

c --- Test for mass units
      ierr=0
      do i=1,nszout
         if(aspunit(i).NE.'g/m2/s          ' .AND.
     &      aspunit(i).NE.'g/m3            ') ierr=ierr+1
      enddo
      if(ierr.GT.0) then
c ---    Report problem information and quit
c ---    Screen (io6) and List File (iolst):
c ---    Set for screen first
         halt132(1:36)='Halted in GETHEAD  --  See list file'
         do i=37,132
            halt132(i:i)=' '
         enddo
c ---    List file unit
         iu=iolst
           write(iu,*)
           write(iu,100) msg0
           do i=1,2
              write(iu,100) msg(i)
           enddo
           WRITE(iu,*)'  *  Data file does not contain mass units for *'
           WRITE(iu,*)'  *  concentration:g/m3 or deposition:g/m2/s   *'
           write(iu,100) msg0
         return
      endif
c
c  Read coordinates of non-gridded receptors (record NCOM+6)
      if(ndrec .NE. 0) read(io) (xrec(i),i=1,ndrec),
     *                          (yrec(i),i=1,ndrec),
     *                          (zrec(i),i=1,ndrec)
c
c  Read coordinates of complex terrain receptors (record NCOM+7)
      if(nctrec .NE. 0) read(io) (xctr(i),i=1,nctrec),
     *                           (yctr(i),i=1,nctrec),
     *                           (zctr(i),i=1,nctrec),
     *                           (ihill(i),i=1,nctrec)
c
c  Generate coordinates of gridded receptors if any are used
      if(LSGRID .AND. ngrec .NE. 0) then
c  Compute coord. for lower-left point in sampling grid, and spacing
         gx0=xorigkm+delx*(isastr-0.5)
         gy0=yorigkm+dely*(jsastr-0.5)
         delgx=delx/meshdn
         delgy=dely/meshdn
c  Fill out arrays
         do i=1,ngx
            do j=1,ngy
               xgrd(i,j)=gx0+(i-1)*delgx
               ygrd(i,j)=gy0+(j-1)*delgy
            enddo
         enddo
      endif

c --- Dataset version 2.1 introduced source names
c --- HEADER RECORDs #NCOM+8 to 15 -- Source names
      if(isrcinfo.EQ.1) then
c ---    Place name for total from all sources in array element 0
         csource(0)='TOTAL           '
         lfatal=.FALSE.
         n2=0
         if(npt1.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+npt1
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.1) lfatal=.TRUE.
         endif
         if(npt2.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+npt2
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.2) lfatal=.TRUE.
         endif
         if(nar1.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+nar1
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.3) lfatal=.TRUE.
         endif
         if(nar2.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+nar2
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.4) lfatal=.TRUE.
         endif
         if(nln1.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+nln1
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.5) lfatal=.TRUE.
         endif
         if(nln2.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+nln2
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.6) lfatal=.TRUE.
         endif
         if(nvl1.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+nvl1
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.7) lfatal=.TRUE.
         endif
         if(nvl2.GT.0 .AND. .NOT.LFATAL) then
            n1=n2+1
            n2=n2+nvl2
            read(io) itype,(csource(n),n=n1,n2)
            if(itype.NE.8) lfatal=.TRUE.
         endif
         if(nsrc.NE.n2) lfatal=.TRUE.
         if(LFATAL) then
c ---       Report problem information and quit
c ---       Screen (io6) and List File (iolst):
c ---       Set for screen first
            halt132(1:36)='Halted in GETHEAD  --  See list file'
            do i=37,132
               halt132(i:i)=' '
            enddo
c ---       List file unit
            iu=iolst
              write(iu,*)
              write(iu,100) msg0
              do i=1,2
                 write(iu,100) msg(i)
              enddo
              write(iu,100)'  *  Unexpected source type found, or     *'
              write(iu,100)'  *  Unexpected source number found.      *'
              write(iu,100)'  *  Number of sources expected:          *'
              write(iu,101)'  *     NPTS',npt1,npt2
              write(iu,101)'  *   NAREAS',nar1,nar2
              write(iu,101)'  *   NLINES',nln1,nln2
              write(iu,101)'  *    NVOLS',nvl1,nvl2
              write(iu,100)'  *  Source Names Read:                   *'
              do i=1,nsrc
                 write(iu,*)'     ',csource(i)
              enddo
              write(iu,100) msg0
            return
         endif
      endif

100   format(1x,a48)
101   format(1x,a12,2(8x,i8),'   *')

      return
      end

c-----------------------------------------------------------------------
      subroutine deltt(j1yr,j1jul,j1hr,j2yr,j2jul,j2hr,jleng)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  890415               DELTT
c --- CALMET   Version: 5.1       Level: 890415     DELTT
c ---          J. Scire, SRC
c
c --- Compute the difference (in hours) between two dates & times
c ---    (time #2 - time #1)
c
c --- INPUTS:
c              J1YR - integer    - Year of date/time #1
c             J1JUL - integer    - Julian day of date/time #1
c              J1HR - integer    - Hour of date/time #1
c              J2YR - integer    - Year of date/time #2
c             J2JUL - integer    - Julian day of date/time #2
c              J2HR - integer    - Hour of date/time #2
c
c --- OUTPUT:
c             JLENG - integer    - Difference (#2 - #1) in hours
c
c --- DELTT called by:  ******
c --- DELTT calls:      none
c-----------------------------------------------------------------------
c
      jmin=min0(j1yr,j2yr)
c
c --- find the number of hours between Jan. 1 of the "base" year and
c --- the first date/hour
      if(j1yr.eq.jmin)then
         j1=0
      else
         j1=0
         j1yrm1=j1yr-1
         do 10 i=jmin,j1yrm1
         if(mod(i,4).eq.0)then
            j1=j1+8784
         else
            j1=j1+8760
         endif
10       continue
      endif
      j1=j1+(j1jul-1)*24+j1hr
c
c --- find the number of hours between Jan. 1 of the "base" year and
c --- the second date/hour
      if(j2yr.eq.jmin)then
         j2=0
      else
         j2=0
         j2yrm1=j2yr-1
         do 20 i=jmin,j2yrm1
         if(mod(i,4).eq.0)then
            j2=j2+8784
         else
            j2=j2+8760
         endif
20       continue
      endif
      j2=j2+(j2jul-1)*24+j2hr
c
c --- compute the time difference (in hours)
      jleng=j2-j1
c
      return
      end
c
c-----------------------------------------------------------------------
      subroutine skiprec(io,tcg,tcd,tct,ix,iy,idrec,itrec,ieof,
     &                   halt132)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS  Version: 6.38          Level: 071001         SKIPREC
c --- CALPOST   Version: 5.633          Level: 031017           SKIPREC
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Reads hourly data records from "concentration" file
c               and passes information to main program through
c               common /conc/, but does not process data.
c               (From GETRCRD)
c
c  CALANALYSIS UPDATES:
c  V5.6(031017) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c  UPDATES:
c  V5.1(990709) to V5.6(031017)
c               (DGS) Add changes for dataset version 2.1 with
c                     source contribution (use RDCONC)
c  V5.0(981025) to V5.1(990709)
c               (DGS) begin & end time resolved to seconds
c  V5.0(980918) to V5.0(981025)
c               (DGS) remove RH variables
c  V5.0(980821) to V5.0(980918)
c               (DGS) Do not skip records in VISB.DAT file, because
c                     it may cover a different period of time
c
c
c  ARGUMENTS:
c     PASSED:   io        Unit number for accessing input file       [i]
c               tcg(i,j)  Temporary gridded receptor array          [ra]
c               tcd(i)    Temporary discrete receptor array         [ra]
c               tct(i)    Temporary complex terrain receptor array  [ra]
c               ix,iy     Dimensions for tcg array                   [i]
c               idrec     Dimension for tcd array                    [i]
c               itrec     Dimension for tct array                    [i]
c               ieof      End of file flag (1=EOF encountered)       [i]
c          HALT132 - character*132     - Status string
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   RDCONC
c-----------------------------------------------------------------------
c
      INCLUDE 'params.ans'
      INCLUDE 'head.ans'
      INCLUDE 'source.ans'
c
c  Declare temporary variables using actual array dimensions
      character*15 tsplv
      real tcg(ix,iy),tcd(idrec),tct(itrec)

      character*132 halt132
c
c  Initialize source loop variables
      isrc=0
      ktype0=-999
      knum0=-999

c  Loop over sources
c ------------------
1     isrc=isrc+1

c ---    Read concentration data 
c ---    Loop over chemical species/levels
         do isl=1,nszout
            call RDCONC(io,isrc,ktype0,knum0,isl,
     &                  tcg,tcd,tct,ix,iy,idrec,itrec,ieof,tsplv,
     &                  halt132)
            if(halt132(1:6) .NE. 'NORMAL') return
            if(ieof.EQ.1) return
         enddo

c --- Loop back for more data if reading source contributions
c --- There should be NSRC+1 (individuals plus total)
      if(isrcindv.GT.0 .AND. isrc.LE.nsrc) goto 1

      return
      end
c
c-----------------------------------------------------------------------
      subroutine getrcrd(io,iorh,tcg,tcd,tct,ix,iy,idrec,itrec,ieof,
     &                   halt132)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40         Level: 071001         GETRCRD
c --- CALPOST   Version: 5.633          Level: 040917           GETRCRD
c ---           D. Strimaitis
c
c  PURPOSE:     Reads data records from "concentration" file for one
c               time period and passes information to main program
c               through commons /conc/ and /vispec/
c
c  CALANALYSIS UPDATES:
c  V5.631(040917) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c  UPDATES:
c  V5.63(031017) to V5.631(040917)
c               (CEC) Add new extinction coefficient computations
c               for method 7 using MM5 liquid water content.
c  V5.5(030627) to V5.6(031017)
c               (DGS) Add changes for dataset version 2.1
c               (DGS) Add source contribution (restructure loops)
c               (DGS) Use discrete receptor array as a source array
c                     when using source TRACEBACK feature (MSRC=2)
c  V5.4(030402) to V5.5(030627)
c               (DGS) Add MVISBK=7 option
c               (DGS) Add additional DEBUG output for visibility
c               (DGS) Add hourly extinction output for visibility
c  V5.2(991104a) to V5.4(030402)
c               (FRR) 2D array of relative humidity  (dimensioned as
c                     actual met grid)
c               (DGS) add list-file unit to INCR, YR4, GRDAY
c               (DGS) replace ndathre with mdathre in GETVSR call
c  V5.1(990920) to V5.2(991104a)
c               (DGS) Add Elemental Carbon as modeled species
c  V5.1(990709) to V5.1(990920)
c               (DGS) Read, but do not process receptor values when
c                     corresponding LG/LD/LCT control is FALSE
c               (DGS) Add logic for MVISBK=6 (RHFACs from control file)
c  V5.0(990228a)to V5.1(990709)
c               (DGS) begin & end time resolved to seconds
c                     and enforce YYYY format for year
c  V5.0(981116) to V5.0(990228a)
c               (DGS) Add gridded receptor exclusion filter
c  V5.0(981025) to V5.0(981116)
c               (DGS) Add Rayleigh bext to nephelometer measurement
c  V5.0(980918) to V5.0(981025)
c               (DGS) Activate LVBK
c               (DGS) Place modeled extinction arrays in /VISPEC/
c               (DGS) Process sub-range of gridded receptors
c  V5.0(980821) to V5.0(980918)
c               (DGS) Add MVISBK=3 option
c               (DGS) Add MVISBK=4 option
c               (DGS) Add record-skipping logic for VISB.DAT file
c  V5.0(980430) to V5.0(980821)
c               (DGS) Add new visibility processing option (MVISBK=2)
c               (DGS) Report F(RH) arrays rather than RH arrays
c               (DGS) Process sub-range of discrete receptors
c
c  V5.0(971007) to V5.0(980430)
c               (DGS) Use LCTSG to determine if data available at
c                     CTSG receptors
c
c  V3.2(960716) to V5.0(971007)
c               (DGS) XWORK2(mxgrec) changed to XWORK2(mxdrec)
c               (DGS) Add EOF processing
c
c  ARGUMENTS:
c     PASSED:   io        Unit number for accessing input file       [i]
c               tcg(i,j)  Temporary gridded receptor array          [ra]
c               tcd(i)    Temporary discrete receptor array         [ra]
c               tct(i)    Temporary complex terrain receptor array  [ra]
c               ix,iy     Dimensions for tcg array                   [i]
c               idrec     Dimension for tcd array                    [i]
c               itrec     Dimension for tct array                    [i]
c               ieof      End of file flag (1=EOF encountered)       [i]
c            imetx,imety  Dimensions for irh2d array                 [i]
c          HALT132 - character*132     - Status string
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   RDCONC, RDRELH, GRDAY, GETWX, GETVSR,
c                       EXRH, GROWTH
c-----------------------------------------------------------------------
c
      INCLUDE 'params.ans'
      INCLUDE 'head.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'conc.ans'
      INCLUDE 'source.ans'
c
c  Declare temporary variables using actual array dimensions
      character*16 cnamsrc
      character*15 tsplv
      character*12 nitrate, sulfate, orgcarb, lmncarb
      real tcg(ix,iy),tcd(idrec),tct(itrec)
      REAL bvis3(mxnxp,mxnyp)
      integer irhss(mxss)
c frr (09/01) 2D array of relative humidity (dimensioned as met grid)
      integer irh2d(mxgx,mxgy)

      character*132 halt132

c --- Species names
      data nitrate/'NO3         '/,sulfate/'SO4         '/
      data orgcarb/'SOA        '/,lmncarb/'EC         '/
c
c --- Factor to convert g/m3 to micro-g/m3 for extinctions
      data fmicro/1.e6/
c
c  Initialize output arrays to zero,
      if(LSGRID) then
         do i=1,ngx
         do j=1,ngy
            concg(i,j)=0.0
         enddo
         enddo
      endif
      if(ndrec .GT. 0) then
         do i=1,ndrec
            concd(i)=0.0
         enddo
      endif
      if(nctrec .GT. 0) then
         do i=1,nctrec
            conct(i)=0.0
         enddo
      endif
c
c  Initialize source loop variables
      isrc=0
      ktype0=-999
      knum0=-999
c
c  Top of loop over sources
c -------------------------
1     isrc=isrc+1

c  Read concentration data, keep species/level to be processed,
c  and store species used for visibility
c --- Loop over chemical species/levels
        do isl=1,nszout

          call RDCONC(io,isrc,ktype0,knum0,isl,
     &                tcg,tcd,tct,ix,iy,idrec,itrec,ieof,tsplv,
     &                halt132)
          if(halt132(1:6) .NE. 'NORMAL') return
          if(ieof.EQ.1) return
            if(LSGRID) then
                if(tsplv(1:12) .EQ. asplvanl(1:12)) then
c --- CEC (070424) - change ibgrid,iegrid,jbgrid,jegrid to 1,ngx,1,ngy
                    do i=1,ngx
                      do j=1,ngy
                        concg(i,j)=tcg(i,j)
                      enddo
                    enddo
                endif
            endif
c
            if(ndrec .GT. 0) then
                 if(tsplv(1:12) .EQ. asplvanl(1:12)) then
                    do i=1,ndrec
                       concd(i)=tcd(i)
                    enddo
                 endif
            endif
c
            if(LCTSG) then
                 if(tsplv(1:12) .EQ. asplvanl(1:12)) then
                    do i=1,nctrec
                       conct(i)=tct(i)
                    enddo
                 endif
            endif
        enddo

c --- Loop back for more data if reading source contributions
c --- There should be NSRC+1 (individuals plus total)
      if(isrcindv.GT.0 .AND. isrc.LE.nsrc) goto 1

c --- Set target date-time for RH data
      mdathrb=myrb*100000+mjdayb*100+mhrb
      mdathre=myre*100000+mjdaye*100+mhre

      return
      end
c-----------------------------------------------------------------------
      subroutine rdconc(io,isrc,ktype0,knum0,ispl,
     &                  tcg,tcd,tct,ix,iy,idrec,itrec,ieof,tsplv,
     &                  halt132)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40          Level: 071001         RDCONC
c --- CALPOST   Version: 5.633          Level: 031017            RDCONC
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Reads header and one block of data records from
c               "concentration" file for one species-level
c
c  CALANALYSIS UPDATES:
c  V5.633(031017) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c  ARGUMENTS:
c     PASSED:   io        Unit number for accessing input file       [i]
c               isrc      Current source index                       [i]
c               ktype0    Last source-type index                     [i]
c               knum0     Last source-number of type ktype0          [i]
c               ispl      Current species-level                      [i]
c               tcg(i,j)  Temporary gridded receptor array          [ra]
c               tcd(i)    Temporary discrete receptor array         [ra]
c               tct(i)    Temporary complex terrain receptor array  [ra]
c               ix,iy     Dimensions for tcg array                   [i]
c               idrec     Dimension for tcd array                    [i]
c               itrec     Dimension for tct array                    [i]
c          HALT132 - character*132     - Status string
c   RETURNED:   ktype0    Last source-type index                     [i]
c               knum0     Last source-number of type ktype0          [i]
c               tcg(i,j)  Temporary gridded receptor array          [ra]
c               tcd(i)    Temporary discrete receptor array         [ra]
c               tct(i)    Temporary complex terrain receptor array  [ra]
c               ieof      End of file flag (1=EOF encountered)       [i]
c               tsplv     Current species-level name                 [c]
c          HALT132 - character*132     - Status string
c
c  CALLING ROUTINES:    GETRCRD
c
c  EXTERNAL ROUTINES:   INCR, YR4, UNCOMPRS
c-----------------------------------------------------------------------
c
      INCLUDE 'params.ans'
      INCLUDE 'head.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'conc.ans'
      INCLUDE 'source.ans'

c --- Declare temporary variables using actual array dimensions
      character*16 cnamsrc
      character*15 tsplv
      real tcg(ix,iy),tcd(idrec),tct(itrec)
      real xwork1(mxgx,mxgy),xwork2(mxdrec),xwork3(mxctrec)

      character*132 halt132

      ieof=0

c --- One set of data records contains header records and then a block
c --- of records for each species-level.  This subroutine reads one such
c --- block of records.

c --- Read header only for the first species-level
      if(ispl.EQ.1) then

c ---    Read time record from "concentration" file
c ---    Note that time uses the 00-23 hour convention so that the 24th
c ---    hour of day 12 has a start time of 23 on day 12 and an end time
c ---    of 00 on day 13

         if(iptime.EQ.1) then
            read(io,end=999) myre,mjdaye,mhre
            msece=0
            msecb=0
            myrb=myre
            mjdayb=mjdaye
            mhrb=mhre
            call INCR(iolst,myrb,mjdayb,mhrb,-1,halt132)
            if(halt132(1:6) .NE. 'NORMAL') return
         elseif(iptime.EQ.2) then
            read(io,end=999) myrb,mjdayb,mhrb,msecb,
     &                       myre,mjdaye,mhre,msece
         else
            write(iolst,*)
            write(iolst,*)'   Invalid time flag IPTIME: ',iptime
            write(iolst,*)'       Expected either 1 or 2'
            write(iolst,*)
            halt132(1:34)='Halted in RDCONC --- see list file'
            do i=35,132
               halt132(i:i)=' '
            enddo
            return
         endif

c ---    Process date-time information
c ---    Enforce YYYY format for year
         call YR4(iolst,myrb,ierrb)
         call YR4(iolst,myre,ierre)
         if(ierrb.NE.0 .OR. ierre.NE.0) then
            halt132(1:34)='Halted in RDCONC --- see list file'
            do i=35,132
               halt132(i:i)=' '
            enddo
            return
         endif

c ---    Read source information record from "concentration" file
         if(isrcinfo.EQ.1) then
            read(io,end=999) ktype,knum,cnamsrc,xskm,yskm
c ---       Total for all sources has ktype=0
            if(ktype.EQ.0) then
               ksrc=0
            else
               ksrc=isrc
            endif
c ---       Check for expected source
            ifatal=0
            if(cnamsrc.NE.csource(ksrc)) ifatal=1
            if(ktype.EQ.ktype0) then
               if(knum.NE.knum0+1) ifatal=1
            elseif(ktype.GT.ktype0 .OR. ktype.EQ.0) then
               if(knum.NE.1) ifatal=1
            else
               ifatal=1
            endif
            if(ifatal.EQ.1) then
               write(iolst,*)
               write(iolst,*)'This source type and number: ',
     &                       ktype,knum
               write(iolst,*)'Last source type and number: ',
     &                       ktype0,knum0
               write(iolst,*)'ERROR in RDCONC - sources are not in',
     &                       ' order'
               write(iolst,*)'   Sequential source number: ',isrc
               write(iolst,*)'       Expected source name: ',
     &                       csource(ksrc)
               write(iolst,*)'          Found source name: ',cnamsrc
               write(iolst,*)
               halt132(1:34)='Halted in RDCONC --- see list file'
               do i=35,132
                  halt132(i:i)=' '
               enddo
               return
            endif
c ---       Pass location to /SOURCE/ arrays
            xsrckm(ksrc)=xskm
            ysrckm(ksrc)=yskm
c ---       Update last source type and number
            ktype0=ktype
            knum0=knum
         endif
      endif

c --- Read "concentration" data for one species-level
c
      if(LSGRID) then
         if(lcomprs)then
            nwords=ix*iy
            read(io)ii
            call UNCOMPRS(xwork1,ii,io,nwords,tsplv,tcg,halt132)
            if(halt132(1:6) .NE. 'NORMAL') return
         else
            read(io) tsplv,tcg
         endif
      endif
c
      if(ndrec .GT. 0) then
         if(lcomprs)then
            read(io)ii
            call UNCOMPRS(xwork2,ii,io,idrec,tsplv,tcd,halt132)
            if(halt132(1:6) .NE. 'NORMAL') return
         else
            read(io) tsplv,tcd
         endif
      endif
c
      if(LCTSG) then
         if(lcomprs)then
            read(io)ii
            call UNCOMPRS(xwork3,ii,io,itrec,tsplv,tct,halt132)
            if(halt132(1:6) .NE. 'NORMAL') return
         else
            read(io) tsplv,tct
         endif
      endif

      return
c
c  EOF encountered in header record
999   ieof=1
      return
c
      end
c-----------------------------------------------------------------------
      subroutine scale
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  890515               SCALE
c --- CALPOST   Version: 5.1            Level: 890515           SCALE
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Applies scaling constants to all concentration data.
c               Data are changed directly in common /conc/.
c
c  ARGUMENTS:   none
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   none
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'conc.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'head.ans'
c
c  Scale gridded receptors
      if(LSGRID) then
         do 5 i=1,ngx
         do 5 j=1,ngy
5           concg(i,j)=concg(i,j)*a+b
      endif
c
c  Scale discrete receptors
      if(ndrec .GT. 0) then
         do 6 i=1,ndrec
6           concd(i)=concd(i)*a+b
      endif
c
c  Scale complex terrain receptors
c      if(nctrec .GT. 0) then
       IF(LCTSG)then
         do 7 i=1,nctrec
7           conct(i)=conct(i)*a+b
      endif
c
      return
      end

c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine sumconc(avcg,avcd,avct,avbg,avbd,avbt,avhg,avhd,avht)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  890515            SUMCONC
c --- CALPOST   Version: 5.1            Level: 890515           SUMCONC
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Sums current concentrations to appropriate averaging
c               array.
c
c  ARGUMENTS:
c     PASSED:   avc[g,d,t]      Updated summing arrays              [ra]
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   none
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'conc.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'head.ans'
c
      real avcg(mxgx,mxgy),avcd(mxdrec),avct(mxctrec)
      real avbg(mxgx,mxgy),avbd(mxdrec),avbt(mxctrec)
      real avhg(mxgx,mxgy),avhd(mxdrec),avht(mxctrec)
c
c  Sum gridded receptor concentrations
      if(LSGRID) then
         do 5 i=1,ngx
         do 5 j=1,ngy
5           avcg(i,j)=avcg(i,j)+concg(i,j)
      endif
c
c  Sum discrete receptor concentrations
      if(ndrec .GT. 0) then
         do 6 i=1,ndrec
6           avcd(i)=avcd(i)+concd(i)
      endif
c
c  Sum complex terrain receptor concentrations
c     if(nctrec .GT. 0) then
      IF(LCTSG)then
         do 7 i=1,nctrec
7           avct(i)=avct(i)+conct(i)
      endif
c
      if(LVISSPEC)then
        if(LSGRID)then
          do i=1,ngx
            do j=1,ngy
              avbg(i,j)=avbg(i,j)+gbext0(i,j)
              avhg(i,j)=avhg(i,j)+grh(i,j)
            enddo
          enddo
        endif
        if(ndrec.gt.0)then
          do i=1,ndrec
            avbd(i)=avbd(i)+dbext0(i)
            avhd(i)=avhd(i)+drh(i)
          enddo
        endif
c        if(nctrec.gt.0)then
        IF(LCTSG)then
          do i=1,nctrec
            avbt(i)=avbt(i)+tbext0(i)
            avht(i)=avht(i)+trh(i)
          enddo
        endif
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine avgconc(n,avcg,avcd,avct,avbg,avbd,avbt,avhg,avhd,avht)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  890515            AVGCONC
c --- CALPOST   Version: 5.1            Level: 890515           AVGCONC
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Divides summed concentration arrays by number of
c               averaging periods to obtain average concentrations
c
c  ARGUMENTS:
c     PASSED:   n               Number of periods in sum             [i]
c   RETURNED:   avc[g,d,t]      Averaged concentration arrays       [ra]
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   none
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'head.ans'
      INCLUDE 'conc.ans'
c
      real avcg(mxgx,mxgy),avcd(mxdrec),avct(mxctrec)
      real avbg(mxgx,mxgy),avbd(mxdrec),avbt(mxctrec)
      real avhg(mxgx,mxgy),avhd(mxdrec),avht(mxctrec)
c
c  Average gridded receptor concentrations
      if(LSGRID) then
         do 5 i=1,ngx
         do 5 j=1,ngy
5           avcg(i,j)=avcg(i,j)/n
      endif
c
c  Average discrete receptor concentrations
      if(ndrec .GT. 0) then
         do 6 i=1,ndrec
6           avcd(i)=avcd(i)/n
      endif
c
c  Average complex terrain receptor concentrations
c      if(nctrec .GT. 0) then
      IF(LCTSG)then
         do 7 i=1,nctrec
7           avct(i)=avct(i)/n
      endif
c
      if(LVISSPEC)then
        if(LSGRID)then
          do i=1,ngx
            do j=1,ngy
              avbg(i,j)=avbg(i,j)/n
              avhg(i,j)=avhg(i,j)/n
            enddo
          enddo
        endif
        if(ndrec.gt.0)then
          do i=1,ndrec
            avbd(i)=avbd(i)/n
            avhd(i)=avhd(i)/n
          enddo
        endif
c        if(nctrec.gt.0)then
        IF(LCTSG)then
          do i=1,nctrec
            avbt(i)=avbt(i)/n
            avht(i)=avht(i)/n
          enddo
        endif
      endif
c
      return
      end
c
c----------------------------------------------------------------------
      subroutine grday(io,iyr,ijul,imo,iday,halt132)
c----------------------------------------------------------------------
c
c --- CALANALYSIS  Version: 6.38     Level: 071001                GRDAY
c --- CALUTILS   Version: 2.3      Level: 000602                  GRDAY
c                J. Scire, SRC
c
c --- PURPOSE:  Compute the Gregorian date (month, day) from the
c               Julian day
c
c  CALANALYSIS UPDATES:
c  V2.3(000602) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c  UPDATES:
c ---               000602  (DGS): YYYY format for year
c
c --- INPUTS:
c            IO - integer      - Unit number for list file output
c           IYR - integer      - Year
c          IJUL - integer      - Julian day
c       HALT132 - character*132 - Status string
c
c --- OUTPUT:
c           IMO - integer      - Month
c          IDAY - integer      - Day
c       HALT132 - character*132 - Status string
c
c --- GRDAY called by:  host subroutines
c --- GRDAY calls:      none
c----------------------------------------------------------------------
      character*132 halt132
c
      integer kday(12,2)
      data kday/31,59,90,120,151,181,212,243,273,304,334,365,
     1          31,60,91,121,152,182,213,244,274,305,335,366/
c
c
      ileap=1
      if(mod(iyr,4).eq.0)ileap=2
      if(ijul.lt.1.or.ijul.gt.kday(12,ileap))go to 11
c
      do 10 i=1,12
      if(ijul.gt.kday(i,ileap))go to 10
      imo=i
      iday=ijul
      if(imo.ne.1)iday=ijul-kday(imo-1,ileap)
      return
10    continue
c
11    continue
         k=30
         k1=k+1
         k2=k+25
         k3=k2+1
         halt132(1:k)=
     &             'Halted in GRDAY:  Invalid date'
         halt132(k1:k2)=
     &             '   --   See the list file'
         do i=k3,132
            halt132(i:i)=' '
         enddo
         write(io,*)halt132(1:k)//' - IYR = ',iyr,' IJUL = ',ijul
         return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine reset(avcg,avcd,avct,avbg,avbd,avbt,avhg,avhd,avht)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  890515              RESET
c --- CALPOST   Version: 5.1            Level: 890515           RESET
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Resets summed concentration arrays to zero after
c               averaged concentrations have been processed.
c
c  ARGUMENTS:
c     PASSED:   avc[g,d,t]      Averaged concentration arrays       [ra]
c
c  CALLING ROUTINES:    CALPOST
c
c  EXTERNAL ROUTINES:   none
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'ctrl.ans'
      INCLUDE 'head.ans'
      INCLUDE 'conc.ans'
c
      real avcg(mxgx,mxgy),avcd(mxdrec),avct(mxctrec)
      real avbg(mxgx,mxgy),avbd(mxdrec),avbt(mxctrec)
      real avhg(mxgx,mxgy),avhd(mxdrec),avht(mxctrec)
c
c  Reset gridded receptor concentrations
      if(LSGRID) then
         do 5 i=1,ngx
         do 5 j=1,ngy
5           avcg(i,j)=0.0
      endif
c
c  Reset discrete receptor concentrations
      if(ndrec .GT. 0) then
         do 6 i=1,ndrec
6           avcd(i)=0.0
      endif
c
c  Reset complex terrain receptor concentrations
c      if(nctrec .GT. 0) then
      IF(LCTSG)then
         do 7 i=1,nctrec
7           avct(i)=0.0
      endif
c
      if(LVISSPEC)then
        if(LSGRID)then
          do i=1,ngx
            do j=1,ngy
              avbg(i,j)=0.
              avhg(i,j)=0.
            enddo
          enddo
        endif
        if(ndrec.gt.0)then
          do i=1,ndrec
            avbd(i)=0.
            avhd(i)=0.
          enddo
        endif
c       if(nctrec.gt.0)then
      IF(LCTSG)then
          do i=1,nctrec
            avbt(i)=0.
            avht(i)=0.
          enddo
        endif
      endif
c
      return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine allcap(cstor2,nlim)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  950531             ALLCAP
c --- CALPOST    Version: 5.1  Level:  950531                 ALLCAP
c ---            J. Scire, SRC
c
c --- PURPOSE:  Convert all lower case letters within a character
c               string to upper case
c
c --- INPUTS:
c
c    CSTOR2(mxcol) - character*1 array - Input character string
c             NLIM - integer           - Length of string (characters)
c        Parameters: MXCOL
c
c --- OUTPUT:
c
c    CSTOR2(mxcol) - character*1 array - Output character string with
c                                        lower case letters converted
c                                        to upper case
c
c --- ALLCAP called by:  READIN
c --- ALLCAP calls:      none
c----------------------------------------------------------------------
c
c --- Include parameter statements
      include 'params.ans'
c
      character*1 cstor2(mxcol),cchar,clc(29),cuc(29)
c
      data clc/'i','n','x','a','e','o','u','b','c','d','f','g','h',
     1 'j','k','l','m','p','q','r','s','t','v','w','y','z','-','.',
     2 '*'/
      data cuc/'I','N','X','A','E','O','U','B','C','D','F','G','H',
     1 'J','K','L','M','P','Q','R','S','T','V','W','Y','Z','-','.',
     2 '*'/
c
      do 100 i=1,nlim
      cchar=cstor2(i)
c
      do 50 j=1,29
      if(cchar.eq.clc(j))then
         cstor2(i)=cuc(j)
         go to 52
      endif
50    continue
52    continue
100   continue
c
      return
      end
c----------------------------------------------------------------------
c----------------------------------------------------------------------
      subroutine julday(io,iyr,imo,iday,ijuldy,halt132)
c----------------------------------------------------------------------
c
c --- CALANALYSIS  Version: 6.38     Level: 071001               JULDAY
c --- CALUTILS   Version: 2.54     Level: 000602                 JULDAY
c ---            J. Scire
c
c --- PURPOSE:  Compute the Julian day number from the Gregorian
c               date (month, day)
c
c  CALANALYSIS UPDATES:
c  V2.54(000602) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c --- INPUTS:
c            IO - integer      - Unit number for list file output
c           IYR - integer      - Year
c           IMO - integer      - Month
c          IDAY - integer      - Day
c       HALT132 - character*132 - Status string
c
c --- OUTPUT:
c          IJUL - integer      - Julian day
c       HALT132 - character*132 - Status string
c
c --- JULDAY called by:  host subroutines
c --- JULDAY calls:      none
c----------------------------------------------------------------------
      character*132 halt132
c
      integer kday(12)
      data kday/0,31,59,90,120,151,181,212,243,273,304,334/
c
c --- Check for valid input data
      ierr=0
c --- Check for valid month
      if(imo.lt.1.or.imo.gt.12)ierr=1
c --- Check for valid day in 30-day months
      if(imo.eq.4.or.imo.eq.6.or.imo.eq.9.or.imo.eq.11)then
         if(iday.gt.30)ierr=1
      else if(imo.eq.2)then
         if(mod(iyr,4).eq.0)then
c ---       February in a leap year
            if(iday.gt.29)ierr=1
         else
c ---       February in a non-leap year
            if(iday.gt.28)ierr=1
         endif
      else
c ---    Check for valid day in 31-day months
         if(iday.gt.31)ierr=1
      endif
c
      if(ierr.eq.1)then
         k=31
         k1=k+1
         k2=k+25
         k3=k2+1
         halt132(1:k)=
     &             'Halted in JULDAY:  Invalid date'
         halt132(k1:k2)=
     &             '   --   See the list file'
         do i=k3,132
            halt132(i:i)=' '
         enddo
         write(io,*)halt132(1:k)//' - IYR = ',iyr,' IMO = ',
     1    imo,' IDAY = ',iday
         return
      endif
c
c --- Compute the Julian day
      ijuldy=kday(imo)+iday
      if(imo.le.2)return
      if(mod(iyr,4).EQ.0)ijuldy=ijuldy+1
c
      return
      end
c----------------------------------------------------------------------
      subroutine uncomprs(xwork,ii,io,nwords,clabel,xdat,halt132)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  071001           UNCOMPRS
c --- CALPOST    Version:  5.1     Level:  960422              UNCOMPRS
c                J. Scire, EARTH TECH
c
c --- PURPOSE:  Read a compressed data records and uncompress
c               the data
c
c  CALANALYSIS UPDATES:
c  V5.1(960422) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c --- INPUTS:
c        XWORK(nwork) - real array - Work array to temporarily store
c                                    compressed array
c                  II - integer    - Number of words in compressed
c                                    data record
c                  IO - integer    - Unit number of input file
c              NWORDS - integer    - Number of values in data array
c                                    after uncompression
c          HALT132 - character*132     - Status string
c
c      PARAMETERS: iolst
c
c --- OUTPUTS:
c              CLABEL - char*15    - Character record header
c        XDAT(nwords) - real array - Array of uncompressed data to be
c                                    output
c          HALT132 - character*132     - Status string
c
c --- UNCOMPRS called by: MAIN
c --- UNCOMPRS calls:     none
c----------------------------------------------------------------------
c
c --- Include parameter statements
      include 'params.ans'
c
      real xwork(ii),xdat(nwords)
      character*15 clabel
      character*132 halt132
c
c --- Read the compressed data record
      read(io)clabel,xwork
c
c --- Uncompress the data
      jj=0
      do 100 i=1,ii
      if(xwork(i).gt.0.0)then
         jj=jj+1
         xdat(jj)=xwork(i)
      else
         nzero=-xwork(i)
         do j=1,nzero
            jj=jj+1
            xdat(jj)=0.0
         enddo
      endif
100   continue
c
c --- QA check that expanded array is correct size
      if(jj.ne.nwords)then
         write(iolst,*)'ERROR in Subr. UNCOMPRS -- Expanded array ',
     1   'is not the correct size -- JJ = ',jj,' NWORDS = ',nwords
         stop
        halt132(1:40)='ERROR in Subr. UNCOMPRS -- See list file'
        do i=41,132
           halt132(i:i)=' '
        enddo
      endif
c
      return
      end
c----------------------------------------------------------------------
      subroutine getdoc(io,ifilver,dataver)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  030627             GETDOC
c --- CALPOST    Version: 5.633    Level: 030627                 GETDOC
c                D. Strimaitis, Earth Tech, Inc.
c
c --- PURPOSE:  Read header comment records of the CALPUFF output
c               data file, and set file type.
c
c --- UPDATES:
c     V5.4(030402) to V5.4(030627)
c               (DGS) Add dataver to output arg list
c
c --- INPUTS:
c            io - integer    - Unit number for CALPUFF file
c
c     COMMON /CTRL/:
c           LDOC
c     Parameters:
c           iolst
c
c --- OUTPUT:
c       ifilver - integer    - Dataset version flag
c                              0: Before 2.0
c                              1: 2.0 or later
c       dataver - C*16       - Dataset version string
c
c --- GETDOC called by:  GETHEAD, GETHDRH
c --- GETDOC calls:      none
c----------------------------------------------------------------------
c
c --- Include parameters
      include 'params.ans'
      include 'ctrl.ans'

c --- Local Variables
      character*16 dataset,dataver,temp16
      character*33 blank33
      character*64 datamod
      character*132 comment1,blank

      data blank33/'                                 '/

c --- Set blank (132 characters)
      blank(1:33)=blank33
      blank(34:66)=blank33
      blank(67:99)=blank33
      blank(100:132)=blank33

c --- Read and test first record to check header format
c --- Record #1 - File Declaration -- 24 words
      read(io) dataset,dataver,datamod
      ifilver=0
      if(dataset.EQ.'CONC.DAT') then
         ifilver=1
      elseif(dataset.EQ.'DFLX.DAT') then
         ifilver=1
      elseif(dataset.EQ.'WFLX.DAT') then
         ifilver=1
      elseif(dataset.EQ.'VISB.DAT') then
         ifilver=1
      endif

      if(ifilver.EQ.0) then
c ---    Old file format with no comment records
         REWIND(io)

      elseif(ifilver.EQ.1) then
         if(LDOC) then
c ---      Read & Write to list file
           write(iolst,*)
           write(iolst,*)
           write(iolst,*)'Header Documentation in CALPUFF file'
           write(iolst,*)'-------------------------------------'
           write(iolst,*)
           write(iolst,*)
           write(iolst,'(2a16,a64)') dataset,dataver,datamod
c ---      Number of comment records
           read(io) ncom
           do i=1,ncom
              comment1=blank
              read(io) comment1
              write(iolst,'(a132)') comment1
           enddo
           write(iolst,*)
           write(iolst,*)
           write(iolst,*)
         else
c ---      Read past doc records
c ---      Number of comment records
           read(io) ncom
           do i=1,ncom
              read(io) comment1
           enddo
         endif
      endif

c --- Prepare dataver string for testing in calling program
      temp16='                '
      k=0
      do i=1,16
         if(dataver(i:i).NE.' ') then
            k=k+1
            temp16(k:k)=dataver(i:i)
         endif
      enddo
      dataver=temp16

      return
      end
c----------------------------------------------------------------------
      subroutine incr(io,iyr,ijul,ihr,nhrinc,halt132)
c----------------------------------------------------------------------
c
c --- CALANALYSIS  Version: 6.38     Level: 110311                 INCR
c --- CALUTILS   Version: 2.1      Level: 000602                   INCR
c                J. Scire, SRC
c
c --- PURPOSE:  Increment the time and date by "NHRINC" hours
c
c  CALANALYSIS UPDATES:
c  V6.38(110301) to V6.39 (110311)
c         - Fix bug when decrementing by less than 24 hours
c           (IWL)
c  V6.27(071001) to V6.30 (080303)
c         - Add possibility to decrement more than 24h, up to 8760h 
c           (CEC)
c  V2.1(000602) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c --- UPDATE
c ---               000602  (DGS): add message to "stop"
c ---               980304  (DGS): Allow for a negative "increment" of
c                                  up to 24 hours
c ---               980304  (DGS): Allow for arbitrarily large nhrinc
c
c --- INPUTS:
c       IO     - integer - Unit number for list file output
c       IYR    - integer - Current year
c       IJUL   - integer - Current Julian day
c       IHR    - integer - Current hour (00-23)
c       NHRINC - integer - Time increment (hours)
c
c               NOTE: "NHRINC" must >= -24
c                      Hour is between 00-23
c      HALT132 - character*132  - Status string
c
c --- OUTPUT:
c       IYR    - integer - Updated year
c       IJUL   - integer - Updated Julian day
c       IHR    - integer - Updated hour (00-23)
c      HALT132 - character*132  - Status string
c
c --- INCR called by: host subroutines
c --- INCR calls:     none
c----------------------------------------------------------------------
      character*132 halt132
c
c --- Check nhrinc
c      if(nhrinc.lt.-24) then
       if(nhrinc.lt.-8760) then
         k=40
         k1=k+1
         k2=k+25
         k3=k2+1
         halt132(1:k)=
     &             'Halted in INCR:  Invalid value of NHRINC'
         halt132(k1:k2)=
     &             '   --   See the list file'
         do i=k3,132
            halt132(i:i)=' '
         enddo
         write(io,*)halt132(1:k)//'-- NHRINC = ',nhrinc
         return
      endif

c --- Save increment remaining (needed if nhrinc > 8760)
      nleft=nhrinc
c
c --- Process change in hour
      if(nhrinc.gt.0)then
c
10       ninc=MIN0(nleft,8760)
         nleft=nleft-ninc
c
c ---    Increment time
         ihr=ihr+ninc
         if(ihr.le.23)return
c
c ---    Increment day
         ijul=ijul+ihr/24
         ihr=mod(ihr,24)
c
c ---    ILEAP = 0 (non-leap year) or 1 (leap year)
         if(mod(iyr,4).eq.0)then
            ileap=1
         else
            ileap=0
         endif
c
         if(ijul.gt.365+ileap) then
c ---       Update year
            iyr=iyr+1
            ijul=ijul-(365+ileap)
         endif
c
c ---    Repeat if more hours need to be added
         if(nleft.GT.0) goto 10
c
      elseif(nhrinc.lt.0)then
c ---    Decrement time
         if(nhrinc.le.-24) then
         ijul1=ijul+(nhrinc/24)
           if(ijul1.le.0) then
           iyr=iyr-1
              if(mod(iyr,4).eq.0)then
              ijul=ijul+366
              else
              ijul=ijul+365
              endif
            endif
           ijul=ijul+(nhrinc/24)
           ihr=ihr+(nhrinc-(int(nhrinc/24)*24))  
             if (ihr.lt.0) then
             ijul=ijul-1  
             ihr=ihr+24     
             endif
         else
           ihr=ihr+nhrinc
           if(ihr.lt.0)then
              ihr=ihr+24
              ijul=ijul-1
              if(ijul.lt.1)then
                 iyr=iyr-1
                 if(mod(iyr,4).eq.0)then
                    ijul=366
                 else
                    ijul=365
                 endif
              endif
           endif
         endif
      endif
c
      return
      end
c----------------------------------------------------------------------
      subroutine yr4(io,iyr,ierr)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40     Level:  991104                YR4
c --- CALUTILS   Version: 2.1      Level: 991104                    YR4
c ---            D. Strimaitis,   Earth Tech
c
c --- PURPOSE: Checks/converts 2-digit year to 4-digit year
c
c --- INPUTS:
c                IO - integer    - Unit number for list file output
c               IYR - integer    - Year (YYYY or YY)
c
c     Common block /Y2K/:
c             IYYLO - integer    - Smallest 2-digit year for which
c                                  'old' century marker is used
c             ICCLO - integer    - 2-digit ('old') century
c
c --- OUTPUT:
c               IYR - integer    - Year (YYYY)
c              IERR - integer    - Error code: 0=OK, 1=FATAL
c
c --- YR4 called by:  Input routines reading 'year' data
c --- YR4 calls:      none
c----------------------------------------------------------------------
c
      common/y2k/iyylo,icclo

      ierr=0

c --- Test for 4-digit year (must exceed 1000)
      if(iyr.GT.1000) then
c ---    Passes 11th Century test (large year not trapped)
         return
      elseif(iyr.LT.100 .AND. iyr.GE.0) then
c ---    2-digit year
c ---    Construct 4-digit year
         if(iyr.LT.iyylo) then
            iyr=(icclo+1)*100+iyr
         else
            iyr=icclo*100+iyr
         endif
      else
c ---    Year not recognized
         ierr=1
         write(io,*)'ERROR in YR4 --- Year not recognized: ',iyr
      endif

      return
      end

c----------------------------------------------------------------------
      subroutine comline(ctext)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40     Level: 040330             COMLINE
c --- CALUTILS   Version: 2.54     Level: 040330                COMLINE
c                J. Scire, SRC
c
c --- PURPOSE:  Call the compiler-specific system routine that will
c               pass back the command line argument after the text
c               that executed the program
c
c               This routine contains calls for several different
c               compilers, but only one should be active at any one
c               time.
c
c --- UPDATE
c --- V2.2 (960521) to V2.3 (040330)  DGS
c               - Replace strings c*70 with c*132
c
c --- INPUTS:
c
c          CTEXT - character*132 - Default command line argument #1
c
c --- OUTPUT:
c
c          CTEXT - character*132 - Command line argument #1
c                                  If command line argument is
c                                  missing, CTEXT is not changed
c
c --- COMLINE called by:  SETUP
c --- COMLINE calls:      GETCL - Lahey system routine
c                         NARGS, GETARG - Microsoft routines
c                         NARGS, GETARG - Compaq DF routines
c                         IARGC, GETARG - Sun routines
c                         IARGC, GETARG - HP routines
c----------------------------------------------------------------------
c
c ----------------------------------------
c --- COMPAQ DF compiler library directive
c *** USE DFLIB
c ----------------------------------------
c
      character*132 ctext,cdeflt
c
c --- Microsoft variables
c *** integer*2 iarg,istat
c
c --- HP declaration
c *** external getarg
c *** external iargc
c
c --- The following is for any system without a command line routine
c --- and is also used as a default
c       cdeflt=ctext
c
c ------------------
c --- Lahey compiler
c ------------------
c       call getcl(ctext)
c
c ----------------------
c --- COMPAQ DF compiler
c ----------------------
c ***  numargs=NARGS()
c ***  if(numargs.ge.1)then
c ***     call GETARG(1,ctext)
c ***  endif
c
c ----------------------
c --- Microsoft compiler
c ----------------------
c *** numargs=NARGS()
c *** if(numargs.ge.1)then
c ***    iarg=1
c ***    call GETARG(iarg,ctext,istat)
c *** endif
c
c ----------------
c --- Sun compiler
c ----------------
       numargs=IARGC()
       if(numargs.ge.1)then
          call GETARG(1,ctext)
       endif
c
c -----------------------------------------------------
c --- HP compiler -- NOTE: needs +U77 switch on compile
c -----------------------------------------------------
c *** numargs=IARGC()
c *** if(numargs.ge.1)then
c ***    call GETARG(1,ctext)
c *** endif
c
c
c --- If no command line arguments, use default
      if(ctext(1:1).eq.' ')ctext=cdeflt

      return
      end

c----------------------------------------------------------------------
      subroutine mltbound(xb,yb,nbndry,nxg,nyg,ndrec1,nctrec1,xgrd,ygrd,
     1   xrec,yrec,xctr,yctr,igrd,idisrec,itrnrec,halt132)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  071001           MLTBOUND
c                J. Scire
c
c --- PURPOSE:  Identify all receptors within a continuous, closed
c               boundary defined by a set of straight-line segments
c               connecting a series of (x,y) data points
c
c  CALANALYSIS UPDATES:
c     V?.?(980504) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c --- JSS - 5/30/91
c
c ----------------------------------------------------------------------
c --- JSS - 11/26/93 - Modified for Alcoa application
c
c ---       (1) Modified to use ISC2 format for receptors instead of
c               CTDM format
c
c ---       (2) Array dimensions increased through use of large
c               parameter values
c
c ---       (3) A second output file with receptors OUTSIDE of the
c               boundary is created (RECEPTOR.OUT), in addition to
c               file with receptors INSIDE the boundary (RECEPTOR.IN)
c ----------------------------------------------------------------------
c SD--- Modified by Shuming Du (5/4/98) to account for multiple boundaries 
c SD--- (a plant can consist of more than one closed boundary lines).
c SD--- Alcoa Massena (NY) facilities have 5 closed boundary lines.
c SD--- Another modification is to print out on the screen 
c SD--- the highest concentration and the corresponding location.
c
c ---  PREVIOUS NOTES & COMMENTS:
c
c **** Modified to write out the receptor UTM coordinates as well as the
c **** relative x,y coordinates.
c **** Currently set for the Long Lake stack as the origin in the data
c **** statement.
c **** Also allows the boundary.dat file to have a header record.
c **** EMI 6/27/91
C ----  MODIFIED OUTPUT FORMAT TO MATCH CTDM RECEPTOR FILE.
C ----  RCM 6/12/91
c
      INCLUDE 'params.ans'
      INCLUDE 'ctrl.ans'
c      INCLUDE 'head.ans'
      INCLUDE 'conc.ans'
c     implicit real*8 (a-h,o-z)
c
      parameter(mxb=5000,mxrec=29000,mxbnd=10)
c      parameter(io6=6,iolst0=10,iolst1=11,iolst2=12,iolst3=13)
c
      real*8 xint(mxb),ZR(MXREC)
      real*8 xr(mxrec),yr(mxrec),xrel(mxrec),yrel(mxrec)
      real xgrd(mxgx,mxgy),ygrd(mxgx,mxgy)
      real xrec(mxrec),yrec(mxrec)
      real xctr(mxrec),yctr(mxrec)
      integer ibsave(mxb),iflag(mxrec,mxbnd)
      integer igrd(mxgx,mxgy),idisrec(mxrec),itrnrec(mxrec)
      logical ldb
      character*80 ajunk
      character*30 ihead
      real*8 x0,y0

      character*132 halt132
c
c --- Center of grid (determines origin of relative coord. system)
      data x0/685500.d0/,y0/3383000.d0/
c
c     data iflag/mxrec*mxbnd*0/,ldb/.true./
      data ldb/.true./
      data nin/0/
c
c --- NOTES:  XB, YB are the coordinates of the boundary points (UTMs)
c             YR, YR are the coordinates of the receptors (UTMs)
c             XREL, YREL are the reeceptor coordinates relative to the
c                    origin (X0, Y0)
c             XINT   contains the x coordinate of each boundary segment
c                    intersecting the Y coordinate of the receptor
c             IFLAG  is an array with a flag indicating if each receptor
c                    is within the boundary (IFLAG(i)=1) or outside the
c                    boundary (IFLAG(i)=0)
c             IBSAVE is a temporary work array with the first segment
c                    number of each pair of segment coordinates which
c                    intersect the Y coordinate of the receptor
c
      nr=0
c
      do ix=1,nxg
      do iy=1,nyg
        x = xgrd(ix,iy)
        y = ygrd(ix,iy)      
 25     format(11x,3f10.0)
        nr=nr+1
        if(nr.gt.mxrec)then
         write(iolst,*)'MLTBOUND ERROR -- too many RECEPTORS --',
     1                ' NR = ',nr,' MXREC =  ',mxrec
         halt132(1:45)='MLTBOUND: too many RECEPTORS -- See list file'
         do i=46,132
           halt132(i:i)=' '
         enddo
         return
        endif
c
        xr(nr)=x
        yr(nr)=y
      enddo
      enddo
      nrgrid = nr
c
      do idsc = 1, ndrec1
        nr=nr+1
        if(nr.gt.mxrec)then
          write(iolst,*)'MLTBOUND ERROR -- too many RECEPTORS --',
     1                  ' NR = ',nr,' MXREC =  ',mxrec
          halt132(1:45)='MLTBOUND: too many RECEPTORS -- See list file'
          do i=46,132
             halt132(i:i)=' '
          enddo
          return
        endif
c
        xr(nr)=xrec(idsc)
        yr(nr)=yrec(idsc)
      enddo
      nrdis = nr
c
      do idsc = 1, nctrec1
        nr=nr+1
        if(nr.gt.mxrec)then
          write(iolst,*)'MLTBOUND ERROR -- too many RECEPTORS --',
     1                 ' NR = ',nr,' MXREC =  ',mxrec
          halt132(1:45)='MLTBOUND: too many RECEPTORS -- See list file'
          do i=46,132
            halt132(i:i)=' '
          enddo
          return
        endif
c
        xr(nr)=xctr(idsc)
        yr(nr)=yctr(idsc)
      enddo
      nrall = nr
c
c
c ---------------------------------------------------------------------
c --- RECEPTOR LOOP
c ---------------------------------------------------------------------
c
      xdist1=9999.
c
      do 1000 irec=1,nr
c --- In this application of mltbound, xrec is renamed as xrec1,
c --- and yrec as yrec2. Doing so is to avoid change the name of the 
c --- array xrec yrec in the whole calanalysis program. --Shuming Du
      xrec1=xr(irec)
      yrec1=yr(irec)
c
c --- Evaluate which receptor is the selected receptor.
	xdist=sqrt((xrec1-xb)**2+(yrec1-yb)**2)
	if (xdist.lt.xdist1) then
	xdist1=xdist
	iflagt=irec
	endif
c
1000  continue
c
c --- WRITE receptors INSIDE boundary to new receptor file
c --- Since all receptor are set as inside the boundary (flag as zero)
c --- Only the receptors selected are flag as 1 - need to be process
c
c      do 3000 i=1,nr
c      if(iflagt.ne.i) then
c        if(i.le.nrgrid) then
c          iix = (i-1)/nyg +1
c          iiy =MOD(i,nyg)
c            if(iiy.eq.0) then
c              iiy = nyg
c            endif 
c          igrd(iix,iiy) = 0
c        elseif(i.gt.nrgrid.and.i.le.nrdis)then
c          ii = i - nrgrid
c          idisrec(ii) = 0
c        elseif(i.gt.nrdis) then
c          iii = i - nrdis
c          itrnrec(iii) = 0
c        endif
c      endif
c
c3000  continue
c
c --- WRITE receptors OUTSIDE boundary to 2nd new receptor file
c
      do 4000 i=1,nr
      if(iflagt.eq.i)then
        if(i.le.nrgrid) then
          iix = (i-1)/nyg +1
          iiy =MOD(i,nyg)
            if(iiy.eq.0) then
              iiy = nyg
            endif 
          igrd(iix,iiy) = 1
        elseif(i.gt.nrgrid.and.i.le.nrdis) then
          ii = i - nrgrid
          idisrec(ii) = 1
c        WRITE(iolst,*)'if discrete receptor, check it is the chosen one:'
c        WRITE(iolst,*)'distance from given point ',xdist1,'recept nb ',ii
        elseif(i.gt.nrdis) then
          iii = i - nrdis
          itrnrec(iii) = 1
        endif
      endif
4000  continue
      return
      end
c-----------------------------------------------------------------------
      subroutine savehead
c-----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40    Level:  050311           SAVEHEAD
c --- POSTUTIL  Version: 1.52           Level: 050311          SAVEHEAD
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Saves header information from first input data file
c               to common /head0/ variables to check against data in
c               subsequent input data files.
c
c  UPDATES:
c     V1.4(040818) to V1.42(050311)
c               (DGS) Allow mix of Dataset 2.* formats
c     V1.2(030210) to V1.4(040818)
c               (DGS) add CALPUFF file Version 2.1 checks
c     V1.1(990806) to V1.2(030210)
c               (JSS) add the file type variable (i2drhu) to the
c                     list of saved variables
c
c  ARGUMENTS:
c               none
c
c  CALLING ROUTINES:    POSTUTIL
c
c  EXTERNAL ROUTINES:   none
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'head.ans'
      INCLUDE 'head0.ans'
c
c  Pass control variables

c
      do i=1,3
         atitle0(i)=atitle(i)
      enddo

      amodel0=amodel
      aver0=aver
      alev0=alev

      msyr0=msyr
      mjsday0=mjsday
      mshr0=mshr
      mssec0=mssec
      mnrun0=mnrun
      mavgpd0=mavgpd
      nsecdt0=nsecdt

      ielmet0=ielmet
      jelmet0=jelmet
      delx0=delx
      dely0=dely
      nz0=nz
      xorigkm0=xorigkm
      yorigkm0=yorigkm
c      nstas0=nstas
      iastar0=iastar
      iastop0=iastop
      jastar0=jastar
      jastop0=jastop
      isastr0=isastr
      isastp0=isastp
      jsastr0=jsastr
      jsastp0=jsastp
      meshdn0=meshdn

      ndrec0=ndrec
      nctrec0=nctrec
      lsgrid0=lsgrid
c      i2drhu0=i2drhu

c
c  Coordinates of non-gridded receptors if any are used
      if(ndrec .NE. 0) then
         do i=1,ndrec
            xrec0(i)=xrec(i)
            yrec0(i)=yrec(i)
            zrec0(i)=zrec(i)
         enddo
      endif
c
c  Coordinates of complex terrain receptors if any are used
      if(nctrec .NE. 0) then
         do i=1,nctrec
            xctr0(i)=xctr(i)
            yctr0(i)=yctr(i)
            zctr0(i)=zctr(i)
            ihill0(i)=ihill(i)
         enddo
      endif

c --- CALPUFF file Version 2.1 checks
      cpver0=cpver
      isrcinfo0=isrcinfo
      isrcindv0=isrcindv

      return
      end
c-----------------------------------------------------------------------
      subroutine testhead(halt132)
c-----------------------------------------------------------------------
c
c --- CALANALYSIS  Version: 6.38          Level: 090227         TESTHEAD
c --- POSTUTIL  Version: 1.52           Level: 050311           TESTHEAD
c ---           D. Strimaitis, SRC
c
c  PURPOSE:     Tests header information from first input data file
c               saved in common /head0/ against data in another
c               subsequent input data file.
c
c  CALANALYSIS UPDATES:
c     V6.27(071001) to V6.34(090227)
c         - Remove warning messages in TESTHEAD when some parameters
c            from the CALPUFF files do not match the parameters of the first
c            file.  These parameters may be different and it is still OK.
c     V1.42(050311) to V6.27(071001)
c         - Add argument variable HALT132 to control early termination
c
c  UPDATES:
c     V1.4(040818) to V1.42(050311)
c               (DGS) Allow mix of Dataset 2.* formats
c     V1.2(030210) to V1.4(040818)
c               (DGS) add CALPUFF file Version 2.1 checks
c     V1.1(010730_1) to V1.2(030210)
c               (JSS) modify checks to include a test on the file type
c                     variable (i2drhu).  Fatal error if file types do
c                     not match [i2drhu=0 (original format), 1 (NO-OBS
c                     format)].  Add new error type (lftyp).
c     V1.1(000712) to V1.1 (010730_1)
c               (JSS) modify checks on header records to allow different
c                     start times, grid characteristics, etc. as long as
c                     receptor coordinates match.  Define match of 
c                     X coordinate to be within 1 m (and elev 0.1 m) to 
c                     eliminate problems with .eq. checks of real numbers.
c                     Write non-fatal warning messages of non-essential
c                     header record variables do not match.
c     V1.1(000106) to V1.1(000712)
c               (JSS) allow data from different versions to be processed
c                     expand data provided in error report
c     V1.0(990806a) to V1.1(000106)
c               (DGS) fix format for error report
c
c  ARGUMENTS:
c          HALT132 - character*132     - Status string
c
c  CALLING ROUTINES:    POSTUTIL
c
c  EXTERNAL ROUTINES:   none
c-----------------------------------------------------------------------
      INCLUDE 'params.ans'
      INCLUDE 'head.ans'
      INCLUDE 'head0.ans'

      logical lfatal,lfatald,lfatalct,lfatals,lwarn,lftyp
      character*132 halt132

c --- Initialize logicals
      lfatal=.FALSE.
      lfatald=.FALSE.
      lfatalct=.FALSE.
      lfatals=.false.
      lwarn=.false.
      lftyp=.false.

c *** Allow data from different models/versions to be processed
      if(amodel0.NE.amodel) lwarn=.TRUE.
      if(aver0.NE.aver) lwarn=.TRUE.
      if(alev0.NE.alev) lwarn=.TRUE.

c *** Allow execution to continue if non-essential header
c *** variables do not match
      if(msyr0.NE.msyr) lwarn=.TRUE.
      if(mjsday0.NE.mjsday) lwarn=.TRUE.
      if(mshr0.NE.mshr) lwarn=.TRUE.
      if(mssec0.NE.mssec) lwarn=.TRUE.
      if(mnrun0.NE.mnrun) lwarn=.TRUE.
      if(mavgpd0.NE.mavgpd) lwarn=.TRUE.
      if(nsecdt0.NE.nsecdt) lwarn=.TRUE.

c *** Grid data need not match as long as sampling grid not used
      if(ielmet0.NE.ielmet) lwarn=.TRUE.
      if(jelmet0.NE.jelmet) lwarn=.TRUE.
      if(delx0.NE.delx) lwarn=.TRUE.
      if(dely0.NE.dely) lwarn=.TRUE.
      if(nz0.NE.nz) lwarn=.TRUE.
      if(xorigkm0.NE.xorigkm) lwarn=.TRUE.
      if(yorigkm0.NE.yorigkm) lwarn=.TRUE.
c      if(nstas0.NE.nstas) lwarn=.TRUE.
      if(iastar0.NE.iastar) lwarn=.TRUE.
      if(iastop0.NE.iastop) lwarn=.TRUE.
      if(jastar0.NE.jastar) lwarn=.TRUE.
      if(jastop0.NE.jastop) lwarn=.TRUE.
      if(isastr0.NE.isastr) lwarn=.TRUE.
      if(isastp0.NE.isastp) lwarn=.TRUE.
      if(jsastr0.NE.jsastr) lwarn=.TRUE.
      if(jsastp0.NE.jsastp) lwarn=.TRUE.
      if(meshdn0.NE.meshdn) lwarn=.TRUE.
c
c --- File types must match (original vs. NO-OBS, MSOURCE)
c --- if critical differences exist
c      if(i2drhu0.NE.i2drhu) lftyp=.true.
      if(cpver0.NE.cpver) then
         if(cpver0.EQ.'0.0             ') lftyp=.true.
         if(cpver.EQ. '0.0             ') lftyp=.true.
      endif
c      if(isrcinfo0.NE.isrcinfo) lftyp=.true.
      if(isrcindv0.NE.isrcindv) lftyp=.true.

c *** Receptors must match
      if(ndrec0.NE.ndrec) lfatal=.TRUE.
      if(nctrec0.NE.nctrec) lfatal=.TRUE.

      if(lsgrid0 .AND. .NOT.lsgrid) lfatal=.TRUE.
      if(.NOT.lsgrid0 .AND. lsgrid) lfatal=.TRUE.
      if(lsgrid0)then
c ***    Grid must match if sampling grid is being used
         if(ielmet0.NE.ielmet) lfatals=.TRUE.
         if(jelmet0.NE.jelmet) lfatals=.TRUE.
         if(delx0.NE.delx) lfatals=.TRUE.
         if(dely0.NE.dely) lfatals=.TRUE.
         if(xorigkm0.NE.xorigkm) lfatals=.TRUE.
         if(yorigkm0.NE.yorigkm) lfatals=.TRUE.
c         if(nstas0.NE.nstas) lfatals=.TRUE.
         if(iastar0.NE.iastar) lfatals=.TRUE.
         if(iastop0.NE.iastop) lfatals=.TRUE.
         if(jastar0.NE.jastar) lfatals=.TRUE.
         if(jastop0.NE.jastop) lfatals=.TRUE.
         if(isastr0.NE.isastr) lfatals=.TRUE.
         if(isastp0.NE.isastp) lfatals=.TRUE.
         if(jsastr0.NE.jsastr) lfatals=.TRUE.
         if(jsastp0.NE.jsastp) lfatals=.TRUE.
         if(meshdn0.NE.meshdn) lfatals=.TRUE.
      endif
c
c --- Coordinates of non-gridded receptors if any are used
c --- must match (within 0.1 m)
      nd=MIN(ndrec,ndrec0)
      if(nd .GT. 0) then
         do i=1,nd
            if(abs(xrec0(i)-xrec(i)).GT.0.001)lfatald=.TRUE.
            if(abs(yrec0(i)-yrec(i)).GT.0.001)lfatald=.TRUE.
            if(abs(zrec0(i)-zrec(i)).GT.0.1)lfatald=.TRUE.
         enddo
      endif
c
c --- Coordinates of complex terrain receptors if any are used
c --- must match (within 0.1 m)
      nct=MIN(nctrec,nctrec0)
      if(nct .GT. 0) then
         do i=1,nct
            if(abs(xctr0(i)-xctr(i)).GT.0.001)lfatalct=.TRUE.
            if(abs(yctr0(i)-yctr(i)).GT.0.001)lfatalct=.TRUE.
            if(abs(zctr0(i)-zctr(i)).GT.0.1)lfatalct=.TRUE.
            if(ihill0(i).NE.ihill(i)) lfatalct=.TRUE.
         enddo
      endif

      if(LFATAL.OR.LFATALD.OR.LFATALCT.or.LFATALS.or.LFTYP) then
        halt132(1:35)='TESTHEAD: Essential header data in '
        halt132(36:73)='CALPUFF.DAT file does not match header'
        halt132(74:116)=' of first CALPUFF.DAT file -- See list file'
        do i=117,132
           halt132(i:i)=' '
        enddo
c ---    Write details to list file
c ---    Write error message to screen
         write(iolst,*)
         write(iolst,*)'TESTHEAD: Essential header data in ',
     1   'CALPUFF.DAT file does not match header of first ',
     2   'CALPUFF.DAT file'
         write(iolst,*)'Execution terminating'
      endif
c
c --- (CEC 090227 - Warning message are removed - too many info in the list files!)
c
c      if(LWARN) then
c ---   Write warning message to screen
c        halt132(1:43)='NORMAL TERMINATION -- WARNING: Some header '
c        halt132(44:83)='data in CALPUFF.DAT file does not match '
c        halt132(84:119)='header of first CALPUFF.DAT file -- '
c        halt132(120:132)='See list file'
c --- write warning message to list file
c       write(iolst,*)'Warning: some header information in the',
c     &               ' CALPUFF.DAT'
c       WRITE(iolst,*)'file does not match the header of the first',
c     &               ' CALPUFF'
c        write(iolst,*)'file - Check list file to confirm intended',
c     1   ' files are being used'
c        write(iolst,*)' '
c      endif
c
c----------------------------------------------------------------------    
c --- (CEC -090227 - remove the warning from the list of FLAGS where info are written)  
c      if(LFATAL.OR.LFATALD.OR.LFATALCT.or.LFATALS.or.LWARN.or.LFTYP)then
       if(LFATAL.OR.LFATALD.OR.LFATALCT.or.LFATALS.or.LFTYP)then
         write(iolst,*)'First CALPUFF.DAT Title:'
         write(iolst,*) atitle0
         write(iolst,*)'Current CALPUFF.DAT Title:'
         write(iolst,*) atitle
         write(iolst,*)
         write(iolst,*)'MSYR0   = ',msyr0,   ' MSYR   = ',msyr
         write(iolst,*)'MJSDAY0 = ',mjsday0, ' MJSDAY = ',mjsday
         write(iolst,*)'MSHR0   = ',mshr0,   ' MSHR   = ',mshr
         write(iolst,*)'MSSEC0  = ',mssec0,  ' MSSEC  = ',mssec
         write(iolst,*)'MNRUN0  = ',mnrun0,  ' MNRUN  = ',mnrun 
         write(iolst,*)'MAVGPD0 = ',mavgpd0, ' MAVGPD = ',mavgpd
         write(iolst,*)'NSECDT0 = ',nsecdt0, ' NSECDT = ',nsecdt
         write(iolst,*)'IELMET0 = ',ielmet0, ' IELMET = ',ielmet
         write(iolst,*)'JELMET0 = ',jelmet0, ' JELMET = ',jelmet
         write(iolst,*)'DELX0   = ',delx0,   ' DELX   = ',delx
         write(iolst,*)'DELY0   = ',dely0,   ' DELY   = ',dely
         write(iolst,*)'NZ0     = ',nz0,     ' NZ     = ',nz
         write(iolst,*)'XORIGKM0= ',xorigkm0,' XORIGKM= ',xorigkm
         write(iolst,*)'YORIGKM0= ',yorigkm0,' YORIGKM= ',yorigkm
c         write(iolst,*)'NSTAS0  = ',nstas0,  ' NSTAS  = ',nstas
         write(iolst,*)'IASTAR0 = ',iastar0, ' IASTAR = ',iastar
         write(iolst,*)'IASTOP0 = ',iastop0, ' IASTOP = ',iastop
         write(iolst,*)'JASTAR0 = ',jastar0, ' JASTAR = ',jastar
         write(iolst,*)'JASTOP0 = ',jastop0, ' JASTOP = ',jastop
         write(iolst,*)'ISASTR0 = ',isastr0, ' ISASTR = ',isastr
         write(iolst,*)'ISASTP0 = ',isastp0, ' ISASTP = ',isastp
         write(iolst,*)'JSASTR0 = ',jsastr0, ' JSASTR = ',jsastr
         write(iolst,*)'JSASTP0 = ',jsastp0, ' JSASTP = ',jsastp
         write(iolst,*)'MESHDN0 = ',meshdn0, ' MESHDN = ',meshdn
         write(iolst,*)'NDREC0  = ',ndrec0,  ' NDREC  = ',ndrec
         write(iolst,*)'NCTREC0 = ',nctrec0, ' NCTREC = ',nctrec
         write(iolst,*)'LSGRID0 = ',lsgrid0, ' LSGRID = ',lsgrid
c         write(iolst,*)'I2DRHU0 = ',i2drhu0, ' I2DRHU = ',i2drhu
         write(iolst,*)'cpver0  = ',cpver0,  ' cpver  = ',cpver
         write(iolst,*)'isrcinfo0=',isrcinfo0,'isrcinfo=',isrcinfo
         write(iolst,*)'isrcindv0=',isrcindv0,'isrcindv=',isrcindv

         write(iolst,101) 'amodel:',amodel0,amodel
101      format(10x,a,2(20x,a))
      endif

      if(LFTYP) then
         write(iolst,*)
         write(iolst,*)'--- File types do not match'
         write(iolst,*)'--- (original vs. NO-OBS, or dataset version)'
         write(iolst,*)
      endif

      if(LFATALD) then
         write(iolst,*)
         write(iolst,*)'--- Discrete receptor coords. are different'
         write(iolst,*)
         nd=MIN(ndrec,ndrec0)
         if(nd .GT. 0) then
            do I=1,nd
               if(abs(xrec0(i)-xrec(i)).gt.0.001 .or.
     1            abs(yrec0(i)-yrec(i)).gt.0.001 .or.
     1            abs(zrec0(i)-zrec(i)).gt.0.1)then
                     write(iolst,*)'Discrete receptor = ',i  
                     write(iolst,*)'   XREC0(i) = ',xrec0(i),
     1                             ' XREC(i)  = ',xrec(i)
                     write(iolst,*)'   YREC0(i) = ',yrec0(i),
     1                             ' YREC(i)  = ',yrec(i)
                     write(iolst,*)'   ZREC0(i) = ',zrec0(i),
     1                             ' ZREC(i)  = ',zrec(i)
               endif                 
            enddo
         endif
      endif

      if(LFATALCT) then
         write(iolst,*)
         write(iolst,*)'--- CTSG receptor coords. are different'
         write(iolst,*)
         nct=MIN(nctrec,nctrec0)
         if(nct .GT. 0) then
            do I=1,nct
               if(abs(xctr0(i)-xctr(i)).gt.0.001 .or. 
     1            abs(yctr0(i)-yctr(i)).gt.0.001 .or. 
     1            abs(zctr0(i)-zctr(i)).gt.0.1 .or. 
     1            ihill0(i).NE.ihill(i))then 
                     write(iolst,*)'CTSG receptor = ',i  
                     write(iolst,*)'   XCTR0(i) = ',xctr0(i),
     1                             ' XCTR(i)  = ',xctr(i)
                     write(iolst,*)'   YCTR0(i) = ',yctr0(i),
     1                             ' YCTR(i)  = ',yctr(i)
                     write(iolst,*)'   ZCTR0(i) = ',zctr0(i),
     1                             ' ZCTR(i)  = ',zctr(i)
                     write(iolst,*)'   IHILL0(i)= ',ihill0(i),
     1                             ' IHILL(i) = ',ihill(i)
               endif
            enddo
         endif
      endif

      if(LFATALS) then
         write(iolst,*)
         write(iolst,*)'--- Sampling grids are different'
         write(iolst,*)
      endif

c      if(LFATAL.OR.LFATALD.OR.LFATALCT.or.LFATALS.or.LFTYP)stop

      return
      end

c----------------------------------------------------------------------
      subroutine FIN
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40            Level: 080418          FIN
c ---            J. Scire, Earth Tech
c
c --- PURPOSE:  Run termination routine -- compute runtime
c
c --- PARAMETERS USED:
c                CALANALYSIS   Parameters
c                iolst, iomsg
c
c --- COMMON BLOCK VARIABLES USED:
c                /QA/ Common Block
c                rcpu, rdate, rtime
c
c --- CALLED BY: MAIN
c
c --- CALLS:     DATETM, JULDAY, DELTT
c
c----------------------------------------------------------------------
c
c --- include parameters
      include 'params.ans'
c
c --- include common blocks
      include 'qa.ans'
c
      character*8 rtime2
      character*10 rdate2
c
      write(iomsg,*)'TERMINATION PHASE'
c
c --- get system date & time at end of run
      call DATETM(rdate2,rtime2,rcpu)
c
c --- compute runtime
      read(rtime(1:2),10)ihr1
      read(rtime(4:5),10)imin1
      read(rtime(7:8),10)isec1
10    format(i2)
      t1=ihr1*3600.+imin1*60.+isec1
c
      read(rtime2(1:2),10)ihr2
      read(rtime2(4:5),10)imin2
      read(rtime2(7:8),10)isec2
      t2=ihr2*3600.+imin2*60.+isec2
c
      if(rdate.eq.rdate2)then
         delt=t2-t1
      else
         read(rdate(1:2),10)imo1
         read(rdate(4:5),10)iday1
         read(rdate(7:10),'(i4)')iyr1
         call JULDAY(iolst,iyr1,imo1,iday1,ijul1)
c
         read(rdate2(1:2),10)imo2
         read(rdate2(4:5),10)iday2
         read(rdate2(7:10),'(i4)')iyr2
         call JULDAY(iolst,iyr2,imo2,iday2,ijul2)
c
c ---    compute no. hours from beg. of first hour of run to
c ---    ending hour of ending day of the run
         call DELTT(iyr1,ijul1,ihr1,iyr2,ijul2,ihr2,idelhr)
c
c ---    adjust for minutes and seconds
         delt=idelhr*3600.-imin1*60.-isec1+imin2*60.+isec2
      endif

c --- On the PC, the runtime and CPU time are the same
c --- (DATETM provides RCPU = 0.0 on the PC)
      if(rcpu.EQ.0.0)rcpu=delt

c --- Report current date
      write(iolst,1402)rtime2,rdate2,delt,rcpu
1402  format(//2x,'End of run -- Clock time: ',a8/
     1         2x,'                    Date: ',a10//
     2         2x,'      Elapsed Clock Time: ',f10.1,' (seconds)'//
     3         2x,'                CPU Time: ',f10.1,' (seconds)')

c
      return
      end

c----------------------------------------------------------------------
      subroutine datetm(rdate,rtime,rcpu)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40            Level: 080418       DATETM
c --- CALUTILS   Version: 2.54     Level: 010731                 DATETM
c ---            J. Scire, SRC
c
c --- PURPOSE:  Get system date and time from system clock
c
c --- INPUTS:  none
c
c --- OUTPUT:  rdate  - C*10 - Current system date (MM-DD-YYYY)
c              rtime  - C*8  - Current system time (HH:MM:SS)
c               rcpu  - real - CPU time (sec) from system utility
c
c --- DATETM called by:  SETUP, FIN
c --- DATETM calls:      DATE, TIME (Lahey F77 compiler utilities)
c                        DATE_AND_TIME (COMPAQ, LF95 compilers)
c                        ETIME (SUN CPU utility program)
c                        YR4C
c----------------------------------------------------------------------
      character*8  rtime
      character*10 rdate

c --- Local store
      character*11 stime
      character*8 sdate

c --- Get system date and time [COMPILER-SPECIFIC!]

cc --- Lahey F77L Compiler (begin)
cc -------------------------------
cc --- System date in MM-DD-YY
cc --- System clock in HH:MM:SS.ss, where ss = hundredths of seconds
c      call DATE(sdate)
c      call TIME(stime)
cc --- Pass to output formats (MM-DD-YYYY) and (HH:MM:SS)
c      rdate='  -  -    '
c      rdate(1:2)=sdate(1:2)
c      rdate(4:5)=sdate(4:5)
c      rdate(7:8)='00'
c      rdate(9:10)=sdate(7:8)
c      do i=1,8
c         rtime(i:i)=stime(i:i)
c      enddo
cc --- Lahey F77L Compiler (end)

c --- COMPAQ DF90/95 and Lahey LF95 Compilers (begin)
c ---------------------------------------------------
c --- System date in CCYYMMDD
c --- System clock in HHMMSS.sss, where sss = thousandths of seconds
      call DATE_AND_TIME(sdate,stime)
c --- Pass to output formats (MM-DD-YYYY) and (HH:MM:SS)
      rdate='  -  -    '
      rdate(1:2)=sdate(5:6)
      rdate(4:5)=sdate(7:8)
      rdate(7:10)=sdate(1:4)
      rtime='  :  :  '
      rtime(1:2)=stime(1:2)
      rtime(4:5)=stime(3:4)
      rtime(7:8)=stime(5:6)
c --- COMPAQ DF90/95 and Lahey LF95 Compilers (end)

c --- Construct 4-digit year from current 2-digit year (if found)
      read(rdate(7:10),'(i4)') iyr
      call YR4C(iyr)
      write(rdate(7:10),'(i4)') iyr

c --- Get CPU time from SUN system utility (or PC dummy)
      call etime(rcpu)

      return
      end

c----------------------------------------------------------------------
      subroutine etime(rcpu)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40            Level: 080418        ETIME
c --- CALUTILS   Version: 2.54     Level: 941215                  ETIME
c ---            J. Scire, SRC
c
c --- PURPOSE:  Dummy system CPU time routine for PC
c               DO NOT USE THIS ROUTINE ON SUNs
c
c --- INPUTS:  none
c
c --- OUTPUT:  RCPU  - real - CPU time (sec) -- set to zero for PC
c
c --- ETIME called by:  DATETM
c --- ETIME calls:      none
c----------------------------------------------------------------------
      rcpu=0.0
c
      return
      end

c----------------------------------------------------------------------
      subroutine yr4c(iyr)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40            Level: 080418         YR4C
c --- CALUTILS   Version: 2.54     Level: 020828                   YR4C
c ---            D. Strimaitis,  Earth Tech
c
c --- PURPOSE: Checks/converts 2-digit year to 4-digit year (CURRENT)
c
c --- UPDATE
c --- V1.0-V1.1     020828  (DGS): Add check for YYYY on input
c
c --- INPUTS:
c               IYR - integer    - Year (YYYY or YY)
c
c --- OUTPUT:
c               IYR - integer    - Year (YYYY)
c
c --- YR4C called by:  host subroutines
c --- YR4C calls:      none
c----------------------------------------------------------------------
c --- Set parameters for converting a current year (1999 - 2098)
c --- Use KCCLO as century digits for years GE KYYLO
      data kyylo/99/, kcclo/19/

c --- Test for 4-digit year (must exceed 1000)
      if(iyr.GT.1000) then
c ---    Passes 11th Century test (large year not trapped)
         return
      elseif(iyr.LT.100 .AND. iyr.GE.0) then
c ---    2-digit year
c ---    Construct 4-digit year
         if(iyr.LT.kyylo) then
            iyr=(kcclo+1)*100+iyr
         else
            iyr=kcclo*100+iyr
         endif
      else
c ---    Year not recognized
         write(*,*)'ERROR in YR4C --- Year not recognized: ',iyr
      endif

      return
      end

c --- KEY_CODE
c----------------------------------------------------------------------
c      subroutine keycalc(cinpfile,inpunit,ikeycalc)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40            Level: 080422      KEYCALC
c
c --- I. Lee, TRC
c
c --- PURPOSE: Calculate integer key code based on input filename
c
c --- UPDATE
c
c --- INPUTS:
c          CINPFILE - character  - Input File Name
c           INPUNIT - integer    - Input File Unit Number
c
c --- OUTPUT:
c          IKEYCALC - integer    - Calculated Key Code
c
c --- KEYCALC called by:  host subroutines
c --- KEYCALC calls:      none
c----------------------------------------------------------------------
c --- Define variables
c      character*132 cinpfile

c --- Initialize variables
c      ikeycalc=0

c --- Determine length of input filename excluding trailing blanks
c      nlen=LEN_TRIM(cinpfile)

c --- Calculate the sum of the ASCII character codes for each character
c     in the input filename
c      do i=1,nlen
c        ikeycalc=ikeycalc+IACHAR(cinpfile(i:i))
c      enddo

c --- Add the file size in bytes of the input file
c      INQUIRE(inpunit,flen=iflen)
c      ikeycalc=ikeycalc+iflen

c      return
c      end

c----------------------------------------------------------------------
      subroutine utcbasr(axtz,xbtz)
c----------------------------------------------------------------------
c
c --- CALANALYSIS   Version: 6.40      Level: 110301            UTCBASR
c ---               F.Robe
c
c --- PURPOSE:  Converts character string UTC time zone 
c               to real base time zone
c
c --- INPUT:
c          AXTZ - char*8    - time zone (international convention: 
c                             relative to UTC/GMT)UTC-HHMM
c --- OUTPUT:
c          XBTZ - real      - base time zone (old convention: positive
c                             in North America i.e. opposite to UTC)
c
c --- UTCBASR called by:  host subroutines
c --- UTCBASR calls:      none
c----------------------------------------------------------------------
      character*8 axtz

      read(axtz(4:6),'(i3)')ihr
      read(axtz(7:8),'(i2)')imin
      if(ihr.lt.0)imin=-imin

      xbtz=ihr+imin/60.

c --- Flip sign as base time convention is opposite UTC/GMT
      xbtz=-xbtz

      return
      end
